{//////////////////////////////////////////////////////////////////////////}
{//                                                                      //}
{//                BIOS.H IMPORT UNIT for GPC                            //}
{//                                                                      //}
{//  v1.00 - by Dr Abimbola A. Olowofoyeku (The African Chief);          //}
{//                                                                      //}
{//  This package is released as part of the GNU Pascal project.         //}
{//                                                                      //}
{//  NOTE - SOME OF THE ROUTINES IN THIS UNIT MAY NOT WORK CORRECTLY.    //}
{//  TEST CAREFULLY AND USE WITH CARE !!!                                //}
{//                                                                      //}
{//  This library is a free library; you can redistribute and/or modify  //}
{//  it under the terms of the GNU Library General Public License,       //}
{//  version 2, as published by the Free Software Foundation.            //}
{//                                                                      //}
{//  This library is distributed in the hope that it will be useful,     //}
{//  but WITHOUT ANY WARRANTY; without even the implied warranty of      //}
{//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       //}
{//  GNU Library General Public License for more details.                //}
{//                                                                      //}
{//  You should have received a copy of the GNU Library General Public   //}
{//  License along with this library (see the file COPYING.LIB);         //}
{//  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,  //}
{//  Cambridge, MA 02139, USA.                                           //}
{//                                                                      //}
{//  v1.00, May 1997 - Dr A Olowofoyeku: laa12@keele.ac.uk               //}
{//  Homepage: http://ourworld.compuserve.com/homepages/African_Chief    //}
{//////////////////////////////////////////////////////////////////////////}
UNIT BIOS;
{$W-}   { !!! no warnings !!! }

INTERFACE

USES GPCTYPES;

function bioscom ( _cmd : Integer;
                 _data : Char; 
                 _port : Integer ) : Integer; C;

function biosdisk ( _cmd : Integer; 
                  _drive : Integer; 
                  _head : Integer; 
                  _track : Integer; 
                  _sector : Integer; 
                  _nsects : Integer; 
                  Var _buffer ) : Integer; C;

function biosequip : Integer; C;

function bioskey ( cmd : Integer ) : Integer; C;

function biosmemory : Integer; C;

function biosprint ( _cmd : Integer;
                   _byte : Integer;
                   _port : Integer ) : Integer; C;

function biostime ( _cmd : Integer;
                  _newtime : LongInt ) : LongInt; C;

{+// }
{-* For compatibility with other DOS C compilers. }
{= }

{+// Disk parameters for _bios_disk() function. */ }

Type _diskinfo_t = record
                     drive : Word;
{= Drive number. }
                     head : Word;
{= Head number. }
                     track : Word;
{= Track number. }
                     sector : Word;
{= Sector number. }
                     nsectors : Word;
{= Number of sectors to read/write/verify. }
                     buffer : Pointer;
{= Buffer for reading/writing/verifying. }
                   end {_diskinfo_t};
Type diskinfo_t = _diskinfo_t;

{+// Constants for _bios_disk() function. */ }
Const _DISK_RESET = 0; {/* Reset disk controller. */}
Const _DISK_STATUS = 1; {/* Get disk status. */}
Const _DISK_READ = 2; {/* Read disk sectors. */}
Const _DISK_WRITE = 3; {/* Write disk sectors. */}
Const _DISK_VERIFY = 4; {/* Verify disk sectors. */}
Const _DISK_FORMAT = 5; {/* Format disk track. */}

{+// Constants fot _bios_serialcom() function. */ }
Const _COM_INIT = 0; {/* Init serial port. */}
Const _COM_SEND = 1; {/* Send character. */}
Const _COM_RECEIVE = 2; {/* Receive character. */}
Const _COM_STATUS = 3; {/* Get serial port status. */}

Const _COM_CHR7 = 2; {/* 7 bits characters. */}
Const _COM_CHR8 = 3; {/* 8 bits characters. */}

Const _COM_STOP1 = 0; {/* 1 stop bit. */}
Const _COM_STOP2 = 4; {/* 2 stop bits. */}

Const _COM_NOPARITY = 0; {/* No parity. */}
Const _COM_ODDPARITY = 8; {/* Odd parity. */}
Const _COM_SPACEPARITY = 16; {/* Space parity. */}
Const _COM_EVENPARITY = 24; {/* Even parity. */}

Const _COM_110 = 0; {/* 110 baud. */}
Const _COM_150 = 32; {/* 150 baud. */}
Const _COM_300 = 64; {/* 300 baud. */}
Const _COM_600 = 96; {/* 600 baud. */}
Const _COM_1200 = 128; {/* 1200 baud. */}
Const _COM_2400 = 160; {/* 2400 baud. */}
Const _COM_4800 = 192; {/* 4800 baud. */}
Const _COM_9600 = 224; {/* 9600 baud. */}

{+// Constants for _bios_keybrd() function. */ }
Const _KEYBRD_READ = 0; {/* Read character. */}
Const _KEYBRD_READY = 1; {/* Check character. */}
Const _KEYBRD_SHIFTSTATUS = 2; {/* Get shift status. */}

Const _NKEYBRD_READ = $10; {/* Read extended character. */}
Const _NKEYBRD_READY = $11; {/* Check extended character. */}
Const _NKEYBRD_SHIFTSTATUS = $12; {/* Get exteded shift status. */}

{+// Constans for _bios_printer() function. */ }
Const _PRINTER_WRITE = 0; {/* Write character. */}
Const _PRINTER_INIT = 1; {/* Initialize printer. */}
Const _PRINTER_STATUS = 2; {/* Get printer status. */}

{+// Constants for _bios_timeofday() function. */ }
Const _TIME_GETCLOCK = 0; {/* Get current clock count. */}
Const _TIME_SETCLOCK = 1; {/* Set current clock count. */}

Function _bios_equiplist : integer; AsmName 'biosequip';
Function _bios_memsize : integer; AsmName 'biosmemory';
Function _bios_printer ( a, b, c : integer ) : integer; AsmName 'biosprint';
Function _bios_serialcom ( a : integer;b : char;c : integer ) : integer; AsmName 'bioscom';
Function _bios_keybrd ( _cmd : integer ) : integer; AsmName 'bioskey';

function _bios_disk ( _cmd : Word;
                    Var _di : _DISKINFO_T ) : Word; C;

function _bios_timeofday ( _cmd : Word;
                         Var _timeval : LongInt ) : Word; C;

IMPLEMENTATION
end.
