{//////////////////////////////////////////////////////////////////////////}
{//                                                                      //}
{//               CHIEF'S UTILS UNIT FOR GPC                             //}
{//                                                                      //}
{//  v1.00 - by Dr Abimbola A. Olowofoyeku (The African Chief);          //}
{//                                                                      //}
{//  This package is released as part of the GNU Pascal project.         //}
{//                                                                      //}
{//  NOTE - SOME OF THE ROUTINES IN THIS UNIT MAY NOT WORK CORRECTLY.    //}
{//  TEST CAREFULLY AND USE WITH CARE !!!                                //}
{//                                                                      //}
{//  !!! Some of the functions in this unit are not portable !!!         //}
{//                                                                      //}
{//  This library is a free library; you can redistribute and/or modify  //}
{//  it under the terms of the GNU Library General Public License,       //}
{//  version 2, as published by the Free Software Foundation.            //}
{//                                                                      //}
{//  This library is distributed in the hope that it will be useful,     //}
{//  but WITHOUT ANY WARRANTY; without even the implied warranty of      //}
{//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       //}
{//  GNU Library General Public License for more details.                //}
{//                                                                      //}
{//  You should have received a copy of the GNU Library General Public   //}
{//  License along with this library (see the file COPYING.LIB);         //}
{//  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,  //}
{//  Cambridge, MA 02139, USA.                                           //}
{//                                                                      //}
{//  v1.00, May 1997 - Dr A Olowofoyeku: laa12@keele.ac.uk               //}
{//  Homepage: http://ourworld.compuserve.com/homepages/African_Chief    //}
{//////////////////////////////////////////////////////////////////////////}
UNIT GPCUTIL;

INTERFACE

USES
GPCTYPES, SYSTEM, DOSH, DOS, STRINGS;

{$X+}    { use extended syntax }
{$W-}    { disable warnings }

{ is "s" a UNC filename? (Windows networks) }
Function  isUNC ( Const s : string ) : boolean;

{ replace all occurences of "oldc" with "newc" in "s"
  and return the result }
Function  ReplaceChar ( s : string; oldc, newc : char ) : string;

{ return the current working directory }
Function  ThisDirectory : string;

{ break a string into 2 parts, using "Ch" as a marker }
Function BreakStr ( Src : String; Var Dest1, Dest2 : String; Ch : Char )
: Boolean;

{ is the year a leap year? }
Function IsLeapYear ( Year : integer ) : Boolean;

{ add #0 to "s" if it isn't already there }
Function AddNull ( Var s : String ) : String;

{///////////////////////////////}
{///////////////////////////////}
{//Turbo Power compatibility ///}
{///////////////////////////////}
{///////////////////////////////}
{ does a string contain wildcard characters? }
Function HasWildCards ( Const s : String ) : Boolean;

{ execute the program "prog"; "dum1" and "dum2" are for
  compatibility only; they are ignored }
Function  ExecDos ( Prog : string; dum1 : boolean; dum2 : pointer ) : integer;

{ return whether "src" exists in the "path" - if so return its
  full location in "dest" }
Function  ExistOnPath ( Src : String; Var Dest : String ) : Boolean;

{ does filename "s" exist? }
Function  ExistFile ( s : string ) : Boolean;AsmName '_p_existfile';

{ return just the directory path of the filename "s"
  strip out the filename part
  ; empty if no pathname exists}
Function  JustPathName ( s : string ) : string;AsmName '_p_justpathname';

{ return just the filename part of the filename "s";
  strip out the directory path; empty if no filename exists }
Function  JustFileName ( s : string ) : string;AsmName '_p_justfilename';

{ return just the extension of the filename "s"; empty if no extension exists }
Function  JustExtension ( Const s : string ) : string;AsmName '_p_justextension';

{ change the extension of "s" to "ext" (do not
  include the dot! }
Function  ForceExtension ( Const s, Ext : string ) : string;AsmName '_p_forceextension';

{ return the full pathname of the filename "s" }
Function  FullPathName ( s : string ) : string;AsmName '_p_fullpathname';

{ add a backslash (or frontslash) to the end of "s"
  if one isn't there already; "PathSeparator" is defined in
  GPCTYPES.PAS as "\" - but for unix you can change it
  to "/" }
Function  AddBackSlash ( Const s : string ) : string;

{ convert integer to pChar }
Function  Int2pChar ( i : integer ) : pChar;

{ convert integer to string }
Function  Int2Str ( i : integer ) : String;

{ convert string to integer }
Function  Str2Int ( s : String; Var i : integer ) : Boolean;

{ convert string to longint }
Function  Str2Long ( s : String; Var i : Longint ) : Boolean;

{ convert string to double }
Function  Str2Real ( s : String; Var i : Double ) : Boolean;

{ return a string stripped of leading spaces }
Function  TrimLead ( Const s : String ) : String;

{ return a string stripped of trailing spaces }
Function  TrimTrail ( Const s : String ) : String;

{ return a string stripped of leading and trailing spaces }
Function  Trim ( Const s : String ) : String;

{ Return a string right-padded to length len with ch }
Function  PadCh ( s : string; ch : Char; len : integer ) : string;

{ Return a string right-padded to length len with spaces }
Function  Pad ( Const s : string; len : integer ) : string;

{ Return a string left-padded to length len with ch }
Function  LeftPadCh ( s : string; ch : Char;len : Byte ) : string;

{ Return a string left-padded to length len with blanks }
Function  LeftPad ( Const s : string; len : integer ) : string;

{ convert a string to lowercase }
Function  StLoCase ( c : string ) : string;

{ convert a string to uppercase }
Function  StUpCase ( c : string ) : string;
{////////////////////////////////}
{////////////////////////////////}
{ Turbo Power compatibility ends }
{////////////////////////////////}
{////////////////////////////////}

{ search for filename "p" in the path and return its
  location (full pathname) }
Function  PathLocate ( p : PChar ) : PChar;

{ helper functions from C lbrary }

{ convert a pChar to a Double }
Function  pChar2Double ( s : PChar ) : Double; AsmName 'atof';

{ convert a pChar to an integer }
Function  pChar2Int ( s : PChar ) : Integer; AsmName 'atoi';

{ convert a pChar to a longint }
Function  pChar2Long ( s : PChar ) : Longint; AsmName 'atol';

{ search the path for a file }
Function  l_searchpath ( aprogram : PChar ) : PChar; AsmName 'searchpath';

{ try to access a file }
Function AccessFile ( path : PChar;
                amode : Integer ) : Integer; AsmName 'access';

{ does the file exist ?}
Function _FileExists ( fn : PChar ) : Integer; AsmName '__file_exists';

{ convert an integer to a pChar }
function  l_itoa ( value : Integer;
              buffer : PChar;
              radix : Integer ) : PChar; AsmName 'itoa';

{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{//// FILE COPY ////////////////}
{///////////////////////////////}
{///////////////////////////////}
{ file copy data structures }
Const
TCopyBufSize = 4 * ( 1024 * 1024 ); { 4mb max buffer size }

Type
pCopyBuf = ^TCopyBuf;
TCopyBuf = Array [ 1 .. TCopyBufSize ] of Byte;

{ copy file Src to file Dest and return the number
  of bytes written}
Function CopyFile ( Src, Dest : String; BufSize : integer ) : Longint;

{ copy file Src to file Dest and return the number
  of bytes written; report the number of bytes written
  versus total size of the source file }
Function CopyFileEx ( Src, Dest : String; BufSize : integer;
                      Function Report ( Reached, Total : Longint ) : Longint ) : Longint;
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{//// SOME CRT FUNCTIONS ///////}
{///////////////////////////////}
{!!! these CRT functions are not portable !!! }
{!!! they use routines from CONIO.H       !!! }

{ read a key and echo it to the screen }
Function  ReadKeyEx : Char; AsmName 'getche';

{ !!! these "write" routines use CONIO to write !!! }
{ !!! so, things like textcolor, etc, will work !!! }

{ write a pChar to the screen - no CRLF }
Procedure WritepChar ( p : pChar );

{ writeln a pChar to the screen - (with CRLF) }
Procedure WritelnPChar ( p : pChar );

{ write a string }
Procedure WriteString ( s : String );

{ writeln a string }
Procedure WritelnString ( s : String );

{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{ C helper functions }
Function remove_f ( filename : PChar ) : Integer; AsmName 'remove';
Function rename_f ( fold : PChar; fnew : PChar ) : Integer; AsmName 'rename';

IMPLEMENTATION
{ helper function from CONIO.H }
function cputs ( xstr : PChar ) : char; C;
function system ( name : pChar ) : integer; C;
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
Function  ThisDirectory : string;
Var
s : string;
Begin
   GetDir ( 0, s );
   ThisDirectory := ChangeFrontSlash ( s );
End; {* ThisDirectory *}
{///////////////////////////////}
Function  ExistOnPath ( Src : String; Var Dest : String ) : Boolean;
Var
p : pChar;
Begin
   Src := ChangeFrontSlash ( Src );
   Dest  := '';
   getmem ( p, 260 );
   AddNull ( Src );
   p := PathLocate ( @Src [1] );
   Dest  := ChangeFrontSlash ( Strpas ( p ) );
   If ( Dest [1] = '.' ) and ( Dest [2] = PathSeparator )
   then begin
      Src := JustFileName ( Dest );
      Dest := AddBackSlash ( ThisDirectory ) + Src;
   end;
   freemem ( p, 260 );
   ExistOnPath := Dest  > '';
End;{*  ExistOnPath *}
{///////////////////////////////}
Function ExistFile ( s : string ) : Boolean;
Begin
   s := ChangeFrontSlash ( s );
   AddNull ( s );
   ExistFile := AccessFile ( @s [1], 0 ) = 0;
End;{* ExistFile  *}
{///////////////////////////////}
Function  JustPathName ( s : string ) : string;
{return the path only - strip filename out}
Var
i : integer;
begin

   s := ChangeFrontSlash ( s );

   for i := length ( s ) downto 0
   do if ( s [i] in [':', PathSeparator] ) then break;

   if i > 0
   then begin

     If IsUnC ( s )
     then begin
        if ( i > 3 ) then {e.g., "\\FRED\smith\me"}
        begin
           s := copy ( s, 1, pred ( i ) );
        end; {else return path; e.g., "\\FRED"}
        JustPathName := ChangeFrontSlash ( s );
        exit;
     end; {isunc}

     s := copy ( s, 1, i );
     if i > 1
     then begin
         if s [pred ( i ) ] in [':', PathSeparator]
         then {ignore; e.g: "C:\FRED" }
         else begin
           if i > 2{s[i]<>':'}
           then Delete ( s, i, 1 ); {e.g.,"C:F2" - return C:}
         end;
       end;{i>1}

      JustPathName := s ;
   end  {i>0}

   else JustPathName := '';
end;{* JustPathName  *}
{/////////////////////////////////////////////////}
Function  JustFileName ( s : string ) : string;
{return the filename only - strip path out}
Var
i : integer;
begin
   s := ChangeFrontSlash ( s );

   for i := length ( s ) downto 0
   do begin
      if ( s [i] in [':', PathSeparator] ) then break;
   end;

   if i > 0
   then begin
     If IsUnc ( s )
     then begin
        If ( i > 2 ) then Delete ( s, 1, i )
        else s := '';{server name or path name only - no filename}
     end
     else Delete ( s, 1, i );
   end; {i>0}

   JustFileName := s;
end;{* JustFileName  *}
{///////////////////////}
Function  FullPathName ( s : string ) : string;
Begin
   s := ChangeFrontSlash ( s );
   If ExistFile ( s )
   then begin
      if JustPathName ( s ) = ''
      then FullPathName := AddBackSlash ( ThisDirectory ) + s
      else FullPathName := s;
   end
   else begin
      FullPathName := s;
   end;
End;{* FullPathName  *}
{///////////////////////////////}
Function  JustExtension ( Const s : string ) : string;
Var
i, j : integer;
s1 : string;
Begin
   s1 := '';

   For j := length ( s ) downto 0 do
   if s [j] = '.' then Break;

   if j > 0 then begin
      for i := Succ ( j ) to length ( s ) do
      s1 := s1 + s [i];
   end;

   JustExtension := s1;
End;{*  JustExtension *}
{///////////////////////}
Function  ForceExtension ( Const s, Ext : string ) : string;
Var
i, j : integer;
s1 : string;
Begin
   s1 := s;
   j  := pos ( '.', s );
   if j > 0 then begin
      s1 := '';
      for i := 1 to Pred ( j ) do
      s1 := s1 + s [i];
   end;
   ForceExtension := s1 + '.' + Ext;
End;{*  ForceExtension *}
{///////////////////////}
Function  AddBackSlash ( Const s : string ) : string;
Var
Ch : char;
Begin
   ch := s [length ( s ) ];
   if Ch <> PathSeparator then
   AddBackSlash := s + PathSeparator else
   AddBackSlash := s;
End;{* AddBackSlash  *}
{///////////////////////////////}
Function  PathLocate ( p : PChar ) : PChar;
Begin
  p := ChangeFrontSlashPChar ( l_searchpath ( p ) );
  PathLocate := p;
End;{* PathLocate  *}
{///////////////////////////////}
Function  ExecDos ( Prog : string; dum1 : boolean; dum2 : pointer ) : integer;
Begin
    Prog := Prog + Chr ( 0 );
    ExecDos := system ( @Prog [1] );
End;{* ExecDos  *}
{///////////////////////////////}
Function TrimLead ( Const s : String ) : String;
Var
i : integer;
ss : string;
b : boolean;
Begin
   ss := s;
   If s [1] = ' ' then begin
      ss := '';
      b := false;
      for i := 1 to length ( s ) do begin
          if s [i] <> ' ' then b := true;
          if b then ss := ss + s [i];
      end;
   end;
   TrimLead := ss;
End; {* TrimLead *}
{//////////////////////////}
Function TrimTrail ( Const s : String ) : String;
Var
i, j : integer;
ss : string;
Begin
   ss := s;
   i := length ( s );
   if s [i] = ' ' then begin
      for j := i downto 1 do if s [j] <> ' ' then break;
      ss := '';
      for i := 1 to j do ss := ss + s [i];
   end;
   TrimTrail := ss;
End;  {* TrimTrail *}
{//////////////////////////}
Function Trim ( Const s : String ) : String;
Begin
   Trim := TrimLead ( ( TrimTrail ( s ) ) );
End;  {* Trim *}
{//////////////////////////}
Function PadCh ( s : string; ch : Char; len : integer ) : string;
Var
i, j : integer;
Begin
   j := length ( s );
   If j < len then begin
      for i := Succ ( j ) to len do begin
       s := s + ch;
      end;
   end;
   PadCh := s;
End; {* PadCh *}
{//////////////////////////}
Function Pad ( Const s : string; len : integer ) : string;
Begin
   Pad := PadCh ( s, Chr ( 32 ), Len );
End;  {* Pad *}
{//////////////////////////}
Function LeftPadCh ( s : string; ch : Char; len : Byte ) : string;
Var
i, j : integer;
Begin
   j := length ( s );
   If j < len then begin
      j := ( len - j );
      for i := 1 to j do
      s := ch + s;
   end;
   LeftPadCh := s;
End; {* LeftPadCh *}
{//////////////////////////}
Function LeftPad ( Const s : string; len : integer ) : string;
Begin
   LeftPad := LeftPadCh ( s, Chr ( 32 ), len );
End; {* LeftPad *}
{///////////////////////////////}
Function StLoCase ( c : string ) : string;
Var
i : integer;
Begin
  for i := 1 to length ( c )
  do c [i] := LoCase ( c [i] );
  StLoCase := c;
End; {* StLoCase  *}
{/////////////////////////////}
Function StUpCase ( c : string ) : string;
Var
i : integer;
Begin
  for i := 1 to length ( c )
  do c [i] := UpCase ( c [i] );
  StUpCase := c;
End; {* StUpCase  *}
{/////////////////////////////}
Function Int2pChar ( i : integer ) : pChar;
Var
p : pChar;
Begin
  getmem ( p, 35 );
  p := l_itoa ( i, p, 10 );
  Int2PChar := p;
  freemem ( p, 35 );
End; {*   *}
{///////////////////////////////}
Function Int2Str ( i : integer ) : String;
Begin
  Int2Str := Strpas ( int2pchar ( i ) );
End; {*   *}
{///////////////////////////////}
Function Str2Int ( s : String; Var i : integer ) : Boolean;
Begin
   AddNull ( s );
   i := pChar2Int ( @s [1] );
   Str2Int := ( i <> 0 );
End; {* Str2Int *}
{////////////////////////}
Function Str2Long ( s : String; Var i : Longint ) : Boolean;
Begin
   AddNull ( s );
   i := pChar2Long ( @s [1] );
   Str2Long := ( i <> 0 );
End; {* Str2Long *}
{////////////////////////}
Function Str2Real ( s : String; Var i : Double ) : Boolean;
Begin
   AddNull ( s );
   i := pChar2Double ( @s [1] );
   Str2Real := ( ErrorNum <> 2 );
End; {* Str2Real *}
{////////////////////////}

{ copy file Src to file Dest and return the number
  of bytes written }
Function CopyFile ( Src, Dest : String; BufSize : integer ) : Longint;
Var
 sH, dH : integer;
 count  : Longint;
 rS, wS : integer;
 Buf    : PCopyBuf;
 T      : TFileTime;
Begin
    CopyFile := - 2;
    sH := OpenFile ( Src );
    If sH < 1 then exit;
    count := 0;
    CopyFile := - 3;
    dH := CreateFile ( Dest );
    If dH < 1 then begin
       count := CloseFile ( sH );
       exit;
    end;
    rS := 1;
    wS := 1;
    Count := GetFileTime ( sH, T );

    If BufSize > TCopyBufSize then BufSize := TCopyBufSize;
    Getmem ( Buf, BufSize );
    Count := 0;

    { loop and do the copying }
    while ( rS > 0 ) and ( wS > 0 )
    do begin
       { read the source file }	
       rS := ReadFile  ( sH, Buf^, BufSize );
       If rS < 0 then begin  {Read Error}
    	  rS := CloseFile ( sH );
    	  rS := CloseFile ( dH );
    	  Freemem ( Buf, BufSize );
    	  CopyFile := - 100; {Read error}
          Exit;
       end;

       { write to the destination file }
       wS := WriteFile ( dH, Buf^, rS );
       If wS < rS then begin  {Error}
    	  rS := CloseFile ( sH );
    	  rS := CloseFile ( dH );
    	  Freemem ( Buf, BufSize );
    	  CopyFile := - 200; {Write error}
          Exit;
       end;
       { increment the count by number of bytes written }
       Count := Count + wS;
    end;
    Freemem ( Buf, BufSize );
    CopyFile := count; { return the number of bytes written }
    rS := CloseFile ( sH );

    Count := SetFileTime ( dH, T );
    rS := CloseFile ( dH );
End; {* CopyFile *}
{///////////////////////////////}
{ copy file Src to file Dest and return the number
  of bytes written; report the number of bytes written
  versus total size of the source file }
Function CopyFileEx ( Src, Dest : String; BufSize : integer;
		     Function Report ( Reached, Total : Longint ) : Longint )
                     : Longint;
Var
 x, y   : Longint;
 sH, dH : integer;
 count  : Longint;
 rS, wS : integer;
 Buf    : PCopyBuf;
 T      : TFileTime;
Begin
    CopyFileEx := - 2;
    sH := OpenFile ( Src );
    If sH < 1 then exit;
    count := 0;
    CopyFileEx := - 3;
    dH := CreateFile ( Dest );
    If dH < 1 then begin
       count := CloseFile ( sH );
       exit;
    end;
    rS := 1;
    wS := 1;
    y := FileSize ( sH );
    Count := GetFileTime ( sH, T );

    If BufSize > TCopyBufSize then BufSize := TCopyBufSize;
    Getmem ( Buf, Bufsize );
    Count := 0;

    { loop and do the copying }
    while ( rS > 0 ) and ( wS > 0 )
    do begin
       { read the source file }
       rS := ReadFile  ( sH, Buf^, BufSize );
       If rS < 0 then begin  {Read Error}
    	  rS := CloseFile ( sH );
    	  rS := CloseFile ( dH );
    	  Freemem ( Buf, BufSize );
    	  CopyFileEx := - 100; {Read error}
          Exit;
       end;

       { write to the destination file }
       wS := WriteFile ( dH, Buf^, rS );
       If wS < rS then begin  {Error}
    	  rS := CloseFile ( sH );
    	  rS := CloseFile ( dH );
    	  Freemem ( Buf, BufSize );
    	  CopyFileEx := - 200; {Write error}
          Exit;
       end;
       
       { progress report }
       If ( @Report <> Nil ) then begin
          x := Report ( wS, y );
          if x < 0 { user abort }
          then begin
    	     rS := CloseFile ( sH );
    	     rS := CloseFile ( dH );
    	     Freemem ( Buf, BufSize );
    	     CopyFileEx := - 300; {User Abort}
    	     Exit;
          end;   
       end;
       
       { increment the count by number of bytes written }
       Count := Count + wS;
    end;

    Freemem ( Buf, BufSize );
    CopyFileEx := count; { return the number of bytes written }
    rS := CloseFile ( sH );

    Count := SetFileTime ( dH, T );
    rS := CloseFile ( dH );
End; {* CopyFileEx *}
{///////////////////////////////}
Procedure WritepChar;
Var
c : Char;
Begin
  c := cputs ( p );
End; {*  WritepChar *}
{///////////////////////////////}
Procedure WriteString ( s : String );
Var
c : Char;
Begin
  AddNull ( s );
  c := cputs ( @s [1] );
End; {* WriteString  *}
{///////////////////////////////}
Procedure WritelnString ( s : String );
Begin
  s := s + Chr ( 13 ) + Chr ( 10 );
  WriteString ( s );
End; {* WritelnString  *}
{///////////////////////////////}
Procedure WritelnPChar ( p : pChar );
Begin
  WritepChar ( p );
  Writeln;
End; {* WritelnPChar  *}
{///////////////////////////////}
Function BreakStr ( Src : String; Var Dest1, Dest2 : String; Ch : Char )
: Boolean;
Var
i, j  : integer;
Begin
   BreakStr := False;
   i := Pos ( Ch, Src );

   If i = 0 then Exit;
   BreakStr := True;

   Dest1 := Src;
   Dest2 := Src;
   j     := length ( Src );
   Delete ( Dest1, i, j );
   Delete ( Dest2, 1, i );
   Dest1 := Trim ( Dest1 );
   Dest2 := Trim ( Dest2 );
End; {* BreakStr *}
{///////////////////////////////}
Function IsLeapYear ( Year : integer ) : Boolean;
Begin
  IsLeapYear :=
  ( ( Year Mod 4 = 0 ) and ( Year Mod 100 <> 0 ) )
  or ( Year Mod 400 = 0 );
End;{* IsLeapYear *}
{///////////////////////////////}
function  isUNC ( Const s : string ) : boolean;
begin
   IsUNC := ( s [1] = '\' ) and ( s [2] = '\' ) and ( Length ( s ) > 3 );
end;{* IsUNC *}
{///////////////////////////////}
Function ReplaceChar ( s : string; oldc, newc : char ) : string;
Var
i : integer;
Begin
  if ( s <> '' ) and ( oldc <> newc )
  then begin
    for i := 1 to length ( s ) do
    if s [i] = oldc then s [i] := newc;
  end;
  ReplaceChar := s;
End;{*  ReplaceChar *}
{///////////////////////////////}
Function HasWildCards ( Const s : String ) : Boolean;
Begin
  HasWildCards :=
   ( Pos ( '*', s ) <> 0 ) or
   ( Pos ( '?', s ) <> 0 );
End;{* HasWildCards *}
{///////////////////////////////}
Function AddNull;
Var
i : integer;
Begin
  i := length ( s );
  if ( s [i] <> Chr ( 0 ) ) then s := s + Chr ( 0 );
  AddNull := s;
End; {* AddNull *}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{$W+}
End.
