{//////////////////////////////////////////////////////////////////////////}
{//                                                                      //}
{//              BORLAND COMPATIBLE "OBJECTS" UNIT for GPC               //}
{//                                                                      //}
{//  v1.00 - by Dr Abimbola A. Olowofoyeku (The African Chief);          //}
{//                                                                      //}
{//  This package is released as part of the GNU Pascal project.         //}
{//  It is NOT 100% compatible with Borland Pascal; some Delphi methods  //}
{//  are included (Create, Destroy, Free)                                //}
{//  check for comments which are marked with "!!!" for some differences //}
{//                                                                      //}
{//  NOTE - SOME OF THE ROUTINES IN THIS UNIT MAY NOT WORK CORRECTLY.    //}
{//  TEST CAREFULLY AND USE WITH CARE !!!                                //}
{//                                                                      //}
{//  This library is a free library; you can redistribute and/or modify  //}
{//  it under the terms of the GNU Library General Public License,       //}
{//  version 2, as published by the Free Software Foundation.            //}
{//                                                                      //}
{//  This library is distributed in the hope that it will be useful,     //}
{//  but WITHOUT ANY WARRANTY; without even the implied warranty of      //}
{//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       //}
{//  GNU Library General Public License for more details.                //}
{//                                                                      //}
{//  You should have received a copy of the GNU Library General Public   //}
{//  License along with this library (see the file COPYING.LIB);         //}
{//  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,  //}
{//  Cambridge, MA 02139, USA.                                           //}
{//                                                                      //}
{//  v1.00, May 1997 - Dr A Olowofoyeku: laa12@keele.ac.uk               //}
{//  Homepage: http://ourworld.compuserve.com/homepages/African_Chief    //}
{//////////////////////////////////////////////////////////////////////////}
UNIT OBJECTS;

INTERFACE

USES GPCTYPES, SYSTEM, XSYSTEM, STRINGS;
{$X+}
{$W-}

Type
ObjectStr = String [ 64 ]; { string type for object names }
{///////////////////////////////}
{//////// TOBJECT //////////////}
{///////////////////////////////}
Type
pObject  = ^TObject;
TObject  = Object
   Parent      : pObject;    { !!! extra  !!!}
   Child       : pObject;    { !!! extra  !!!}
   Name        : ObjectStr;  { Delphi }
   Handle      : Integer;    { Delphi: window handle for windowed objects }
   SelfID      : Integer;    { !!! unique ID for each instance !!!}

   Procedure   Free;virtual;     { disposes of @Self and calls Destroy }

   { BP }
   Constructor Init;
   Destructor  Done;virtual;
   Constructor Load ( Var S : TObject ); {!!! doesn't exist in BP !!!}

   { Delphi }
   Destructor  Destroy;virtual;
   Constructor Create ( aOwner : pObject );

   {$ifndef __GPC__}
   private
   {$endif}
   SelfPtr : pObject;  { !!! extra: pointer to Self !!! }
End; {* TObject *}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{ terminate program with runtime error no: 211 }
Procedure Abstract;
{///////////////////////////////}
{////  access functions ////////}
{///////////////////////////////}
{ !!! return a pointer to an object instance, via its window handle !!! }
Function InstanceFromHandle ( Const aHandle : Integer;Var aReturn : Integer ) : pObject;

{ !!! return a pointer to an object instance, via its self ID !!! }
Function InstanceFromSelfID ( Const anID : Integer ) : pObject;
{///////////////////////////////}
{//////// STREAMS //////////////}
{///////////////////////////////}
{ buffer type for streams }
Type
pStreamBuf = ^TStreamBuf;
TStreamBuf = TByteArray;

{ access modes and other stuff for streams }
Const
stCreate     = $3C00;
stOpenRead   = $3D00;
stOpenWrite  = $3D01;
stOpen	     = $3D02;
stOk	     = 0;
stError	     = - 1;
stInitError  = - 2;
stReadError  = - 3;
stWriteError = - 4;
stGetError   = - 5;
stPutError   = - 6;

Type  { !!! not complete !!! }
pStream = ^TStream;
TStream = Object ( TObject )
   ErrorInfo : integer;
   Status    : integer;
   Procedure Put ( p : PObject );virtual;
   Function  Get : PObject;virtual;
   Function  GetSize : Longint; virtual;
   Function  GetPos : Longint; virtual;
   Procedure Error ( Code, Info : Integer ); virtual;
   Procedure Flush; virtual;
   { !!! Read is a procedure under BP !!!}
   Function  Read ( var Buf; Count : integer ) : integer; virtual;
   { !!! Write is a procedure under BP !!!}
   Function  Write ( var Buf; Count : integer ) : integer; virtual;
   Procedure Reset; virtual;
   Procedure Seek ( Pos : Longint );virtual;
   Procedure Truncate; virtual;
   Function  StrRead : PChar; virtual;
   Procedure StrWrite ( p : PChar ); virtual;
   Function  ReadStr : PString; virtual;
   Procedure WriteStr ( p : PString ); virtual;
   Procedure CopyFrom ( var S : TStream; Count : Longint );virtual;
End; {* TStream *}
{///////////////////////////////}
Type  { !!! not complete !!! }
pDosStream = ^TDosStream;
TDosStream = Object ( TStream )
   sFile : BinFile; { !!! private !!! }
   
   { !!! mode only knows to create or to open with read/write access !!! }
   Constructor Init ( FileName : String; Mode : Word );
   Destructor  Done; virtual;
   Function    GetPos : Longint; virtual;
   Function    GetSize : Longint; virtual;
   Function    Read ( var Buf; Count : integer ) : integer; virtual;
   Function    Write ( var Buf; Count : integer ) : integer; virtual;
   Procedure   Seek ( Pos : Longint );virtual;
   Procedure   Truncate; virtual;
End; {* TDosStream *}
{///////////////////////////////}
Type  { !!! not complete - almost the same as TDosStream !!! }
pBufStream = ^TBufStream;
TBufStream = Object ( TDosStream )
   Buffer : PChar; { !!! pointer in BP - dummy: not used !!! }
   BufSize,        { !!! dummy: not used !!!}
   BufPtr,         { !!! dummy: not used !!!}
   BufEnd : Word;  { !!! dummy: not used !!!}

   { !!! mode only knows to create or to open with read/write access !!! }
   Constructor Init ( FileName : String; Mode, Size : Word );
   Destructor  Done; virtual;
   Function    GetPos : Longint; virtual;
   Function    GetSize : Longint; virtual;
   Function    Read ( var Buf; Count : integer ) : integer; virtual;
   Function    Write ( var Buf; Count : integer ) : integer; virtual;
   Procedure   Seek ( Pos : Longint );virtual;
   Procedure   Truncate; virtual;
End; {* TDosStream *}
{///////////////////////////////}
{///////////////////////////////}
{//// COLLECTIONS //////////////}
{///////////////////////////////}
{///////////////////////////////}
{ callback function type for TCollection routines }
Type
{$ifdef __GPC__}
ForEachProc = ^Function ( Item : Pointer ) : Boolean;
{$else}
ForEachProc =  Function ( Item : Pointer ) : Boolean;
{$endif}

{ TCollection error codes }
Const
coIndexError = - 1; { Index out of range }
coOverflow   = - 2; { Collection overflow }

{maximum number of items in "collections"}
Const               { 1 million     * 64 = 64 million}
MaxCollectionSize = ( 1000 * 1000 ) * 64;

{array of pointers for "collection"}
Type  {starts at ZERO - but the ZERO'th item is not used!}
TItemList  = Array  [ 0 .. MaxCollectionSize ] of pointer;
pItemList  = ^TItemList;
{///////////////////////////////}
{///////////////////////////////}
{///// TCOLLECTION /////////////}
{///////////////////////////////}
{///////////////////////////////}
{ Base Collection object - can be used as is - but
  these methods MUST be overridden in descendant objects;
             ( RemoveItem )
      and
      either ( Equal, and Less and Greater )
      or     ( Compare )
}
Type
pCollection = ^TCollection;
TCollection = Object ( TObject )

    { the collection items - read only !}
    Items   : pItemList;

    { private counter - do not change manually }
    I_Count : integer;

    { private counter - do not change manually }
    C_ItemMax : integer;

    { number of items by which to increase the collection when full }
    Delta : integer;

    {!!! whether duplicates are allowed - only in BP's TSortedCollection !!!}
    Duplicates : Boolean;

    { !!! whether list should be sorted !!! }
    Sorted    : Boolean;

    {Create the object - with maxnum-1 as the maximum
    number of items allowed. "aDelta" is just a dummy -
    it is provided for compatibility}
    Constructor Init   ( MaxNum : longint;Const aDelta : Integer );
    Constructor Create ( MaxNum : longint;Const aDelta : Integer );

    Destructor  Destroy;virtual;
    Destructor  Done;virtual;

    {returms number of items in collection}
    Function    Count : Integer;virtual;

    {add an item to the end of the collection}
    Function    Insert ( Item : Pointer ) : Boolean;virtual;

    {deletes the item at Index - and adjusts list}
    Function    AtDelete ( Index : Integer ) : Boolean;virtual;
    {same as AtDelete}
    Function    AtFree ( Index : Integer ) : Boolean;virtual;

    {delete the item : equal to AtDelete(IndexOf(Item))}
    Function    Delete ( Item : Pointer ) : Boolean;virtual;

    {same as Delete}
    Function    FreeMe ( Item : Pointer ) : Boolean;virtual;

    {deletes all items in collection - calls Nullify to do
    this}
    Procedure   DeleteAll;virtual;

    {!!! same as DeleteAll !!! }
    Procedure   Clear; virtual;

    { !!! frees the memory for the item - must be overridden !!!}
    { !!! in BP, the parameter is a  pointer !!! }
    Function    RemoveItem ( index : integer ) : Boolean;virtual;

    {returns the index of the item - or 0 if not found}
    Function    IndexOf ( Item : Pointer ) : Integer; virtual;

    {inserts the item at index and pushes down list}
    Function    AtInsert ( Index : Integer;Item : Pointer ) : Boolean;virtual;

    {returns the item at "index"}
    Function    At ( Index : Integer ) : Pointer;virtual;

    {searches for the item - and returns its index
    in Index}
    Function    Search ( Item : pointer;Var Index : Integer ) : Boolean;virtual;

    {!!! specifies whether item1 is less than item2
    - must be overridden in each descendant object !!! }
    Function    Less ( Item1, Item2 : Pointer ) : Boolean;virtual;

    { !!! specifies whether item1 is greater than item2
    - must be overridden in each descendant object !!! }
    Function    Greater ( Item1, Item2 : Pointer ) : Boolean;virtual;

    { !!! specifies whether item1 is the same as item2
    - must be overridden in each descendant object !!! }
    Function    Equal ( Item1, Item2 : Pointer ) : Boolean;virtual;

    { compares item1 with item2 by calling Less, Equal, and Greater }
    { !!! do not change the implementation in TCollection itself !!! }
    Function    Compare ( Item1, Item2 : Pointer ) : integer;virtual;

    { !!! deletes the item at index !!! }
    Function    Nullify ( Index : Integer ) : Boolean;virtual;

    {!!! sorts the collection - according to returns by
    Less, Equal, and Greater !!! }
    Procedure   SortAll;virtual;

    {!!! sorts the collection - from Start to Stop !!! }
    Procedure   Sort ( Start, Stop : integer );virtual;

    { !!! replaces the item at index with item - no search for
    duplicates and no change to the count !!! }
    Function    AtChange ( Index : Integer; Item : Pointer ) : Boolean;virtual;

    {replaces the item at index with item, searches for
    duplicates, and increases the count}
    Function    AtPut ( Index : Integer;Item : Pointer ) : Boolean;virtual;

    {loops through the items and submits each item to a
    function  pointed to by "Action"}
    Procedure   Foreach ( Action : {$ifdef __GPC__}ForEachProc{$else}Pointer{$endif} );virtual;

    {loops through the items and submits each item to a
    function pointed to by "Test", until "Test" returns true}
    Function    FirstThat ( Test : {$ifdef __GPC__}ForEachProc{$else}Pointer{$endif} ) : Pointer;virtual;

    {loops through the items in reverse order and submits
    each item to a function pointed to by "Test", until
    "Test" returns true}
    Function    LastThat ( Test : {$ifdef __GPC__}ForEachProc{$else}Pointer{$endif} ) : Pointer;virtual;

    Function    Limit : integer; { !!! field in BP !!! }

    Procedure   Pack;  { !!! does nothing !!! }

    Procedure   SetLimit ( ALimit : integer ); virtual;

    { gives a runtime error }
    Procedure   Error ( Code, Info : Integer ); virtual;

    { free the item - by calling its Done destructor }
    Procedure   FreeItem ( Item : Pointer ); virtual;

    { stream stuff }
    Function    GetItem ( var S : TStream ) : Pointer; virtual;
    Procedure   PutItem ( var S : TStream; Item : Pointer ); virtual;
    Procedure   Store ( var S : TStream );
    Constructor Load ( var S : TStream );

    {$ifndef __GPC__}
    Private
    {$endif}
       I_Max : Integer;

      { !!! is it safe to proceed? private procedure - do not call by yourself! }
      Function UnsafeToProceed ( What : integer ) : Boolean;

      { !!! pulls up the list - do not call by yourself!}
      Function    PullUpList ( Start : Integer ) : Boolean;

      { !!! pushes down the list - do not call by yourself!}
      Function    PushDownList ( Start : Integer ) : Boolean;

      {  !!! - size of memory to allocate - do not call by yourself !}
      Function    Multi : longint;
End; {* TCollection *}
{///////////////////////////////}
{/// TSORTEDCOLLECTION /////////}
{///////////////////////////////}
Type { !!! TCollection is already sortable !!! }
pSortedCollection = ^TSortedCollection;
TSortedCollection = Object ( TCollection )
    Constructor Init   ( MaxNum : longint;Const aDelta : Integer );
    Constructor Create ( MaxNum : longint;Const aDelta : Integer );
End; {* TSorted Collection *}
{///////////////////////////////}
{//// TSTRCOLLECTION ///////////}
{///////////////////////////////}
Type
pStrCollection = ^TStrCollection;
TStrCollection = Object ( TSortedCollection )

    Destructor  Destroy;virtual;
    Destructor  Done;virtual;

    {is item1 less than item2 - overridden method}
    Function    Less ( Item1, Item2 : Pointer ) : Boolean;virtual;

    {is item1 greater than item2 - overridden method}
    Function    Greater ( Item1, Item2 : Pointer ) : Boolean;virtual;

    {is item1 equal to item2 - overridden method}
    Function    Equal ( Item1, Item2 : Pointer ) : Boolean;virtual;

    {dispose of the string - overridden method}
    Function    RemoveItem ( Index : Integer ) : Boolean;virtual;

    {!!! add a string to the list !!! }
    Function    Add ( Item : String ) : Boolean;virtual;

    {!!! replace the string at index !!! }
    Function    Replace ( Index : Integer; Item : String ) : Boolean;virtual;

    {!!! add a pChar to the list !!! }
    Function    AddPChar ( Item : pChar ) : Boolean;virtual;

    {!!! replace the pChar at index !!! }
    Function    ReplacePChar ( Index : Integer; Item : pChar ) : Boolean;virtual;

    {!!! return as a Pascal string the item at index !!! }
    Function    Strings ( Index : Integer ) : String;virtual;

    {!!! return as a null terminated string the item at index !!! }
    Function    pChars ( Index : Integer ) : pChar;virtual;

    { !!! Delphi: read contents of text file into collection}
    Function    ReadFromFile ( Const FName : String ) : integer;virtual;

    { !!! Delphi: write all the strings in collection to text file}
    Function    WriteToFile ( Const FName : String ) : integer;virtual;

    { overridden }
    Procedure   FreeItem ( Item : Pointer ); virtual;

    { overridden }
    Function    GetItem ( var S : TStream ) : Pointer; virtual;

    { overridden }
    Procedure   PutItem ( var S : TStream; Item : Pointer ); virtual;
End;{* TStrCollection *}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
IMPLEMENTATION
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
Procedure Abstract;
Begin
  RunError ( 211 );
End; {* Abstract *}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{ !!! local counter to allocate unique handles !!! }
Var
ObjectCount : Longint value - 1;
Junk : Longint;

{ !!! record for object list !!! }
Type
pListUnit = ^TListUnit;
TListUnit  = Record
    Next      : pListUnit;
    TheObject : pObject;
End; {* TListUnit *}

{ !!! local object for manipulating list      !!! }
{ !!! to store pointers to all active objects !!!}
Type
pObjectList = ^ObjectList;
ObjectList  = Object ( TObject )
    Head : pListUnit;
    Constructor Create ( aOwner : pObject );
    Procedure   Free;virtual;
    Procedure   Insert ( NewObject : pObject ); Virtual;
    Procedure   UserFree ( TheObject : pObject ); Virtual;
    Procedure   UserLocate ( Var Found : Boolean; Const aHandle : Integer;TheObject : pObject ); virtual;
    Procedure   UserLocate2 ( Var Found : Boolean; Const aHandle : Integer;TheObject : pObject ); virtual;
    Procedure   Remove ( TheObject : pObject ); virtual;
    Function    Count : Integer; Virtual;
    Procedure   AdjustTotCount; Virtual;
    Function    FindFromHandle ( Const H : Integer ) : pObject;
    Function    FindFromSelfID ( Const H : Integer ) : pObject;
End; {* ObjectList *}
{////////////////////////////////}
{////////////////////////////////}
{////// OBJECTLIST //////////////}
{////////////////////////////////}
Constructor ObjectList.Create;
begin
  Inherited Create ( aOwner );
  Head := Nil;
End;  {* ObjectList.Create *}
{///////////////////////////////}
Procedure ObjectList.UserLocate;
Begin
  Found := TheObject^.SelfID = aHandle;
End;  {* ObjectList.UserLocate *}
{///////////////////////////////}
Procedure ObjectList.UserLocate2;
Begin
  Found := TheObject^.SelfID = aHandle;
End;  {* ObjectList.UserLocate2 *}
{///////////////////////////////}
Procedure ObjectList.UserFree;
Begin
   {TheObject:=Nil;}
End;  {* ObjectList.UserFree *}
{///////////////////////////////}
Function ObjectList.FindFromHandle;
Var
  Found : Boolean;
  N     : pListUnit;
Begin
  Found := False;
  N     := Head;
  FindFromHandle := Nil;
  While ( Found = False ) and ( N <> Nil ) do begin
    UserLocate ( Found, H, N^.TheObject );
    If Found then FindFromHandle := N^.TheObject;
    N := N^.Next;
  End;
End;  {* ObjectList.FindFromHandle *}
{///////////////////////////////}
Function ObjectList.FindFromSelfID;
Var
  Found : Boolean;
  N     : pListUnit;
Begin
  Found := False;
  N     := Head;
  FindFromSelfID := Nil;
  While ( Found = False ) and ( N <> Nil ) do begin
    UserLocate2 ( Found, H, N^.TheObject );
    If Found then FindFromSelfID := N^.TheObject;
    N := N^.Next;
  End;
End;   {* ObjectList.FindFromSelfID *}
{///////////////////////////////}
Procedure ObjectList.Free;
Var
  N : pListUnit;
Begin
  While Head <> Nil Do Begin
    N := Head;
    Head := N^.Next;
    UserFree ( N^.TheObject );
    Dispose ( N );
  End;
  Inherited Free;
End;  {* ObjectList.Free *}
{///////////////////////////////}
Procedure ObjectList.Insert;
Var
  N : pListUnit;
Begin
  New ( N );
  N^.Next := Head;
  N^.TheObject := NewObject;
  Head := N;
End;  {* ObjectList.Insert *}
{///////////////////////////////}
Function ObjectList.Count;
Var
  N : pListUnit;
  i : Integer;
Begin
  N := Head;
  Count := 0;
  i := 0;
  While N <> Nil
  Do Begin
    Inc ( i );
    N := N^.Next;
  End;
  Count := i;
End;  {* ObjectList.Count *}
{///////////////////////////////}
Procedure ObjectList.AdjustTotCount;
Var
  N : pListUnit;
  i : Integer;
Begin
  N := Head;
  i := 0;
  While N <> Nil
  Do Begin
    Inc ( i );
    N^.TheObject^.SelfID := i;
    N := N^.Next;
  End;
  ObjectCount := i;
End;  {* ObjectList.AdjustTotCount *}
{///////////////////////////////}
procedure ObjectList.Remove;
Var
  N, F : pListUnit;
  i   : Integer;
Begin
  N := Head;
  F := N;
  i := 0;
  If Not ( Assigned ( TheObject ) ) then Exit;
  While ( N <> Nil )
  Do Begin
    inc ( i );
    If  ( N^.TheObject = TheObject )
    Then Begin {remove it}
      UserFree ( N^.TheObject );
      If N = Head then Head := N^.Next
      Else F^.Next := N^.Next;

      If ( N^.TheObject^.SelfID = ObjectCount )
      then Dec ( ObjectCount );

      Dispose ( N );
      N := Nil;
    End{remove it}
    else begin
      F := N;
      N := N^.Next;
    End;
  End;
End;  {* ObjectList.Remove *}
{///////////////////////////////}
{///////////////////////////////}
{ !!! object instance to hold the list of active objects !!! }
Var
aList : ObjectList;
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{ find an object instance from its Handle }
Function InstanceFromHandle;
Begin
    aReturn := 0;
    InstanceFromHandle := aList.FindFromHandle ( aHandle );
End; {* InstanceFromHandle *}
{///////////////////////////////}
{ find an object instance from its SelfID }
Function InstanceFromSelfID;
Begin
    InstanceFromSelfID := aList.FindFromSelfID ( anID );
End; {* InstanceFromSelfID *}
{///////////////////////////////}
{///////////////////////////////}
{///// TOBJECT /////////////////}
{///////////////////////////////}
{///////////////////////////////}
Constructor TObject.Load;
Begin
End;  {* TObject.Load *}
{///////////////////////////////}
Constructor TObject.Init;
Begin
   SelfPtr := @Self;
   Parent  := Nil;     { !!! difference b/w Init and Create !!! }
   Child   := Nil;
   Handle  := 0;
   Name    := 'TObject';
   Inc ( ObjectCount );
   SelfID := ObjectCount;
   aList.Insert ( @Self );
End;  {* TObject.Init *}
{///////////////////////////////}
Constructor TObject.Create;
Begin
   SelfPtr := @Self;
   Child   := Nil;
   Handle  := 0;
   Parent  := aOwner;     { !!! difference b/w Init and Create !!! }
   Name    := 'TObject';
   Inc ( ObjectCount );
   SelfID := ObjectCount;
   aList.Insert ( @Self );
End;  {* TObject.Create *}
{///////////////////////////////}
Destructor TObject.Done;
Begin
   Handle  := - 108; { to show that we have been freed }
   Name    := '';
   Parent  := Nil;
   SelfPtr := Nil;  { Mark that we are already freed }
   aList.Remove ( @Self );
End;  {* TObject.Done *}
{///////////////////////////////}
Destructor TObject.Destroy;
Begin  { this can be different from --> Done() }
   Handle  := - 108; { to show that we have been freed }
   Name    := '';
   Parent  := Nil;
   SelfPtr := Nil;  { Mark that we are already freed }
   aList.Remove ( @Self );
End;  {* TObject.Destroy *}
{///////////////////////////////}
Procedure TObject.Free;
Begin
   If   ( SelfPtr <> Nil )   { check that we are not already freed }
   and  ( Handle  <> - 108 )  {              ditto                  }
   and  ( Name    <> '' )    {              ditto                  }
   then Dispose ( pObject ( @Self ), Done );
End;   {* TObject.Free *}
{///////////////////////////////}
{///////////////////////////////}
{////////  TSTREAM  ////////////}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
Procedure TStream.Put;
Var
i : integer;
Begin
   If ( p <> Nil )
   then i := Sizeof ( p^ )
   else i := 0;
   Write ( i, Sizeof ( integer ) );
   If ( p <> Nil ) then Write ( p^, i );
End; {* TStream.Put *}
{///////////////////////////////}
Function  TStream.Get;
Var
i : integer;
p : pObject;
Begin
  Read ( i, Sizeof ( integer ) );
  if ( i = 0 ) then Get := nil
  else begin
    New ( p, {Init}Load ( p^ ) );
    Read ( p^, i );
    Get := p;
  end;
End; {* TStream.Get *}
{///////////////////////////////}
Function  TStream.GetSize;
Begin
  {Abstract;}
End; {* TStream.GetSize *}
{///////////////////////////////}
Function  TStream.GetPos;
Begin
  {Abstract;}
End; {* TStream.GetPos *}
{///////////////////////////////}
Procedure TStream.Error;
Begin
    Status := Code;
    ErrorInfo := Info;
End; {* TStream.Error *}
{///////////////////////////////}
Procedure TStream.Flush;
Begin
End; {* TStream.Flush *}
{///////////////////////////////}
Function  TStream.Read;
Begin
  {Abstract;}
End; {* TStream.Read *}
{///////////////////////////////}
Function  TStream.Write;
Begin
  {Abstract;}
End; {* TStream.Write *}
{///////////////////////////////}
Procedure TStream.Reset;
Begin
   Status := stOk;
   ErrorInfo := stOk;
End; {* TStream.Reset *}
{///////////////////////////////}
Procedure TStream.Seek;
Begin
  {Abstract;}
End; {* TStream.Seek *}
{///////////////////////////////}
Procedure TStream.Truncate;
Begin
  {Abstract;}
End; {* TStream.Truncate *}
{///////////////////////////////}
Function  TStream.StrRead;
Var
i : integer;
p : pChar;
Begin
  Read ( i, Sizeof ( integer ) );
  if ( i = 0 ) then StrRead := nil
  else begin
    GetMem ( p, i + 1 );
    Read ( p [0], i );
    p [i] := Chr ( 0 );
    StrRead := StrNew ( p );
    FreeMem ( p, i + 1 );
  end;
End; {* TStream.StrRead *}
{///////////////////////////////}
Procedure TStream.StrWrite;
Var
i : integer;
Begin
  If ( p = nil )
  then i := 0
  else i := StrLen ( p );
  Write ( i, Sizeof ( integer ) );
  if ( p <> nil ) then Write ( p [0], i );
End; {* TStream.StrWrite *}
{///////////////////////////////}
Function  TStream.ReadStr;
Var
i : integer;
p : pString;
Begin
  Read ( i, Sizeof ( integer ) );
  if ( i = 0 ) then ReadStr := nil
  else begin
    GetMem ( p, i + 1 );
    Read ( p^ [1], i );
    ReadStr := p;
  end;
End; {* TStream.ReadStr *}
{///////////////////////////////}
Procedure TStream.WriteStr;
Var
i : integer;
None : String [1];
Begin
  None := '';
  If ( p = nil )
  then i := 1
  else i := Length ( p^ ) + 1;

  Write ( i, Sizeof ( integer ) );

  if ( p <> nil )
  then Write ( p^, i )
  else Write ( None, i )
End; {* TStream.WriteStr *}
{///////////////////////////////}
Procedure TStream.CopyFrom;
Var
buf : pStreamBuf;
Begin
  GetMem ( Buf, Count + 1 );
  S.Read ( buf^, Count );
  Write ( buf^, Count );
  FreeMem ( Buf, Count + 1 );
End; {* TStream.CopyFrom *}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{//// TDOSSTREAM ///////////////}
{///////////////////////////////}
{///////////////////////////////}
Constructor TDosStream.Init;
Var
b : boolean;
Begin
   Inherited Init;
   b := false;
   Status := stError;
   If BinAssign ( sFile, FileName )
   then begin
      If ( Mode = stCreate )
      then b := BinReWrite ( sFile )
      else b := BinReset ( sFile );
      if b then begin
        Handle := sFile.Handle;
        Status := stOk;
      end;
   end; {if BinAssign}
   If not b then Error ( stInitError, stInitError );
End; {* TDosStream.Init *}
{///////////////////////////////}
Destructor  TDosStream.Done;
Begin
   TDosStream.Flush;
   BinClose ( sFile );
   Inherited Done;
End; {* TDosStream.Done *}
{///////////////////////////////}
Function    TDosStream.GetPos;
Begin
   If ( Status = stOk )
   then begin
     Junk := BinFilePos ( sFile );
     If Junk < 0 then Error ( stError, stError ) 
     else GetPos := Junk;
   end else GetPos := - 1;
End; {* TDosStream.GetPos *}
{///////////////////////////////}
Function    TDosStream.GetSize;
Begin
   If ( Status = stOk )
   then begin
      Junk := BinFileSize ( sFile );
      If Junk < 0 then Error ( stError, stError )
      else GetSize := Junk;
   end else GetSize := - 1;
End; {* TDosStream.GetSize *}
{///////////////////////////////}
Function    TDosStream.Read;
Var
i : integer;
Begin
    If ( Status = stOk ) then begin
       BlockRead ( sFile, Buf, Count, i );
       Read := i;
       If ( i < 1 ) {or ( Count <> i )}
       then Error ( stReadError, stReadError );
    end;   
End; {* TDosStream.Read *}
{///////////////////////////////}
Function    TDosStream.Write;
Var
i : integer;
Begin
   If ( Status = stOk ) then begin
      BlockWrite ( sFile, Buf, Count, i );
      Write := i;
      If ( i < 1 ) or ( Count <> i ) then Error ( stWriteError, stWriteError );
   end;
End; {* TDosStream.Write *}
{///////////////////////////////}
Procedure   TDosStream.Seek;
Begin
   If ( Status = stOk ) then begin
     If Not BinSeek ( sFile, Pos ) then Error ( stError, stError );
   end; 
End; {* TDosStream.Seek *}
{///////////////////////////////}
Procedure   TDosStream.Truncate;
Begin
   If ( Status = stOk ) then begin
     Junk := GetPos;
     If Junk >= 0 then
     If Not BinTruncate ( sFile, Junk )
     then Error ( stError, stError );
   end;  
End; {* TDosStream.Truncate *}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{//// TBUFSSTREAM //////////////}
{///////////////////////////////}
{///////////////////////////////}
Constructor TBufStream.Init;
Begin
   Inherited Init ( FileName, Mode );
   BufPtr := 0;
   BufEnd := 0;
   If Status = stOk then begin
      BufSize := Size;
      GetMem ( Buffer, BufSize );
   end;
End; {* TBufStream.Init *}
{///////////////////////////////}
Destructor  TBufStream.Done;
Begin
  {If Status = stOk then }FreeMem ( Buffer, BufSize );
  TBufStream.Flush;
  Inherited Done;
End; {* TBufStream.Done *}
{///////////////////////////////}
Function    TBufStream.GetPos;
Var
l : longint;
Begin
    l := TDosStream.GetPos;
    GetPos := l;
End; {* TBufStream.GetPos *}
{///////////////////////////////}
Function    TBufStream.GetSize;
Var
l : longint;
Begin
    l := TDosStream.GetSize;
    GetSize := l;
End; {* TBufStream.GetSize *}
{///////////////////////////////}
Function    TBufStream.Read;
Begin
   Read := Inherited Read ( Buf, Count );
End; {* TBufStream.Read *}
{///////////////////////////////}
Function    TBufStream.Write;
Begin
   Write := Inherited Write ( Buf, Count );
End; {* TBufStream.Write *}
{///////////////////////////////}
Procedure   TBufStream.Seek;
Begin
   Inherited Seek ( Pos );
End; {* TBufStream.Seek *}
{///////////////////////////////}
Procedure   TBufStream.Truncate;
Begin
   TBufStream.Flush;
   Inherited Truncate;
End; {* TBufStream.Truncate *}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{/// TCOLLECTION, ETC. /////////}
{///////////////////////////////}
{///////////////////////////////}
Function Access ( path : PChar; amode : Integer ) : Integer; C;
{ does the file exist? }
Function ExistFile ( s : string ) : Boolean;
Begin
   s := s + chr ( 0 );
   ExistFile := Access ( @s [1], 0 ) = 0;
End;{* ExistFile  *}
{///////////////////////////////}
{ quicksort a TCollection - from "Lo" to "Hi" }
Procedure SortCollection ( A : pCollection; Const Lo, Hi : Integer );
{ nested procedure }
procedure Sort ( l, r : Integer );
var
  i, j, k : Integer;
  x, y : pointer;

begin
  i := l;
  j := r;
  k := ( l + r ) DIV 2;

 With a^ do begin

  x := items^ [k];

  repeat

    while Compare ( items^ [i], x ) < 0 do i := i + 1;
    while Compare ( x, items^ [j] ) < 0 do j := j - 1;

    if i <= j
    then begin
      y := items^ [i];
      atChange ( i, items^ [j] );
      atChange ( j, y );
      i := i + 1; j := j - 1;
    end;

  until i > j;

  if l < j then sort ( l, j );
  if i < r then sort ( i, r );
 end;{with a}

end;{sort}

Begin {SortCollection};
  sort ( Lo, Hi );
End;{ * SortCollection *}
{///////////////////////////////}
{///////////////////////////////}
{////////// TCOLLECTION ////////}
{///////////////////////////////}
{///////////////////////////////}
Constructor TCollection.Init;
Begin
   Inherited Init;
   I_Count    := 0;

   If ( MaxNum < 1 ) or ( MaxNum > MaxCollectionSize )
   then MaxNum := MaxCollectionSize;

   C_ItemMax  := MaxNum;
   I_Max      := Multi;
   Delta      := aDelta;
   Duplicates := False;
   Sorted     := False;
   Name       := 'TCollection';

   MemAlloc ( Items, I_Max );
End;{* TCollection.Init *}
{///////////////////////////////}
Constructor TCollection.Create;
Begin
   Inherited Create ( Nil );
   I_Count    := 0;

   If ( MaxNum < 1 ) or ( MaxNum > MaxCollectionSize )
   then MaxNum := MaxCollectionSize;

   C_ItemMax  := MaxNum;
   I_Max      := Multi;
   Delta      := aDelta;
   Duplicates := False;
   Sorted     := False;
   Name       := 'TCollection';

   MemAlloc ( Items, I_Max );
End;{* TCollection.Create *}
{///////////////////////////////}
Destructor TCollection.Destroy;
Begin
   MemFree ( Items );
   I_Count := 0;
   Inherited Destroy;
End;{* TCollection.Destroy *}
{///////////////////////////////}
Destructor TCollection.Done;
Begin
   MemFree ( Items );
   I_Count := 0;
   Inherited Done;
End;{* TCollection.Done *}
{///////////////////////////////}
Function TCollection.Count;
Begin
   Count := I_Count;
End;{* TCollection.Count *}
{///////////////////////////////}
{ mem size to allocate }
Function TCollection.Multi;
Begin
  Multi := ( C_ItemMax + 2 ) * Sizeof ( Pointer );
End;{* TCollection.Multi *}
{///////////////////////////////}
{ if we should not add more items }
Function TCollection.UnsafeToProceed;
Begin
   UnsafeToProceed := False;
   If ( What > C_ItemMax ) then begin
      If Delta < 1 then UnsafeToProceed := True
      else begin
          If ( ( C_ItemMax + Delta ) > MaxCollectionSize )
          then UnsafeToProceed := True
          else begin
             Inc ( C_ItemMax, Delta );
             MemAlloc ( Items, Multi );
          end;
      end;
   end;
End;{* TCollection.UnsafeToProceed *}
{///////////////////////////////}
Function    TCollection.Insert ( Item : Pointer ) : Boolean;
Var
Junk : integer;
Begin
    Insert := False;
    If UnsafeToProceed ( I_Count + 1 ) then exit;
    If Item <> Nil
    then begin

       If ( Duplicates = False ) then
       if Search ( Item, Junk ) then Exit;

       If ( I_Count >= C_ItemMax ) then PullUpList ( 1 );

       Inc ( I_Count );

       Items^ [I_Count] := Item;
       Insert := True;
    End;
End;{* TCollection.Insert *}
{///////////////////////////////}
Function    TCollection.AtInsert ( Index : Integer;Item : Pointer ) : Boolean;
Begin
    AtInsert := False;
    If ( UnsafeToProceed ( Index ) ) or ( Index < 1 ) then exit;
    PushDownList ( Index );
    AtInsert := AtPut ( Index, Item );
End;{* TCollection.AtInsert *}
{///////////////////////////////}
Function    TCollection.At ( Index : Integer ) : Pointer;
Begin
    At := Nil;
    If ( Index > C_ItemMax ) or ( Index < 1 ) then Exit;
    At := Items^ [Index];
End;{* TCollection.At *}
{///////////////////////////////}
Function    TCollection.Less;
{ !!! doesn't work - must be overridden !!! }
Begin
   Less := integer ( @Item1 ) < integer ( @Item2 );
End;{* TCollection.Less *}
{///////////////////////////////}
Function    TCollection.Greater;
{ !!! doesn't work - must be overridden !!! }
Begin
   Greater := integer ( @Item1 ) > integer ( @Item2 );
End;{* TCollection.Greater *}
{///////////////////////////////}
Function    TCollection.Equal;
{ !!! doesn't work - must be overridden !!! }
Begin
   Equal := integer ( @Item1 ) = integer ( @Item2 );
End;{* TCollection.Equal *}
{///////////////////////////////}
Function   TCollection.Compare;
{ !!! depends on Greater, Equal, and Less  !!! }
Var
i : integer;
Begin
    If Equal ( Item1, Item2 ) then i := 0 else
    If Less  ( Item1, Item2 ) then i := - 1 else
    If Greater ( Item1, Item2 ) then i := 1;
    Compare := i;
End;{* TCollection.Compare *}
{///////////////////////////////}
Function   TCollection.PullUpList;
Var
i : Integer;
Begin
  PullUpList := False;
  If ( Start < 1 ) or ( Start > I_Count ) then Exit;

  Nullify ( Start );

  For i := Start to i_Count
  do begin
      AtChange ( i, Items^ [Succ ( i ) ] );
  end;
  Items^ [Succ ( I_Count ) ] := Nil;
End;{* TCollection.PullUpList *}
{///////////////////////////////}
Function   TCollection.PushDownList;
Var
i : Integer;
Begin
  PushDownList := False;
  If ( Start < 1 ) or ( Start > I_Count ) then Exit;
  For i := Succ ( I_Count ) downto Start
  do begin
      If ( i = 1 ) and ( Start = 1 ) then {} else
      AtChange ( i, Items^ [Pred ( i ) ] );
  end;
End;{* TCollection.PushDownList *}
{///////////////////////////////}
Function    TCollection.RemoveItem;
Begin
    RemoveItem := False;
    If ( Index > C_ItemMax ) or ( Index < 1 )
    or ( Index > I_Count ) then Exit;
    Items^ [Index] := Nil;
    RemoveItem := True;
End;{* TCollection.RemoveItem *}
{///////////////////////////////}
Function   TCollection.Nullify;
Begin
    Nullify := False;
    If RemoveItem ( Index ) then begin
       Items^ [Index] := Nil;
       Dec ( I_Count );
       Nullify := True;
    end;
End;{* TCollection.Nullify *}
{///////////////////////////////}
Function   TCollection.AtPut;
Var
Junk : integer;
Begin
    AtPut := False;
    If ( Index < 1 ) or ( UnsafeToProceed ( Index ) ) then exit;

    If ( Duplicates = False )
    then if Search ( Item, Junk ) then Exit;

    Inc ( I_Count );

    Items^ [Index] := Item;
    AtPut := True;
End;{* TCollection.AtPut *}
{///////////////////////////////}
Function   TCollection.AtChange;
Begin
    AtChange := False;

    If ( Index > C_ItemMax ) or ( Index < 1 ) then Exit;

    Items^ [Index] := Item;
    AtChange := True;
End;{* TCollection.AtChange *}
{///////////////////////////////}
Function   TCollection.AtDelete;
Begin
    AtDelete := False;
    If ( Index > C_ItemMax ) or ( Index < 1 )
    or ( Index > I_Count ) then Exit;
    AtDelete := True;
    If Index = I_Count then Nullify ( Index )
    else begin
       PullUpList ( Index );
    end;
End;{* TCollection.AtChange *}
{///////////////////////////////}
Function   TCollection.AtFree;
Begin
   AtFree := AtDelete ( Index );
End;{* TCollection.AtFree *}
{///////////////////////////////}
Function   TCollection.Search;
Var
i : Integer;
Begin
   Search := False;
   i := IndexOf ( Item );
   If i > 0 then begin
      Search := True;
      Index := i;
   End;
End;{* TCollection.Search *}
{///////////////////////////////}
Procedure TCollection.SortAll;
Begin
   SortCollection ( @Self, 1, I_Count );
End;{* TCollection.SortAll *}
{///////////////////////////////}
Procedure  TCollection.Sort;
Begin
   SortCollection ( @Self, Start, Stop );
End;{* TCollection.Sort *}
{///////////////////////////////}
Procedure   TCollection.Foreach;
Var
i : Integer;
fP: ForeachProc;
Begin
   If ( I_Count < 1 ) or ( Action = Nil ) then Exit;
   {$ifdef __GPC__}
   fp := Action;
   {$else}
   @fP := Action;
   {$endif}
   For i := 1 to I_Count do fP ( Items^ [i] );
End;{* TCollection.ForEach *}
{///////////////////////////////}
Function    TCollection.FirstThat;
Var
i : Integer;
fP : ForeachProc;
Begin
   FirstThat := Nil;
   If ( I_Count < 1 ) or ( Test = Nil ) then Exit;
   {$ifdef __GPC__}
   fp := Test;
   {$else}
   @fP := Test;
   {$endif}
   For i := 1 to I_Count do
   begin
      If fP ( Items^ [i] )
      then begin
         FirstThat := Items^ [i];
         Exit;
      end;
   end;
End;{* TCollection.FirstThat *}
{///////////////////////////////}
Function    TCollection.LastThat;
Var
i : Integer;
fP : ForeachProc;
Begin
   LastThat := Nil;
   If ( I_Count < 1 ) or ( Test = Nil ) then Exit;
   {$ifdef __GPC__}
   fp := Test;
   {$else}
   @fP := Test;
   {$endif}
   For i := I_Count Downto 1 do
   begin
      If fP ( Items^ [i] )
      then begin
         LastThat := Items^ [i];
         Exit;
      end;
   end;
End;{* TCollection.LastThat *}
{///////////////////////////////}
Function  TCollection.Delete;
Begin
   Delete := AtDelete ( IndexOf ( Item ) );
End;{* TCollection.Delete *}
{///////////////////////////////}
Function  TCollection.FreeMe;
Begin
   FreeMe := Delete ( Item );
End;{* TCollection.FreeMe *}
{///////////////////////////////}
Function  TCollection.IndexOf;
Var
i : Integer;
Begin
   IndexOf := - 1;
   If Item = Nil then Exit;

   for i := 1 to I_Count
   do begin
      if ( Items^ [i] <> Nil ) and ( Equal ( Items^ [i], Item ) )
       then begin
          IndexOf  := i;
          Exit;
       end;
   end;
End;{* TCollection.IndexOf *}
{///////////////////////////////}
Procedure TCollection.DeleteAll;
Var
i, j : Integer;
Begin
  j := I_Count;
  For i :=  j downto 1 do Nullify ( i );
End;{* TCollection.DeleteAll *}
{///////////////////////////////}
Procedure TCollection.Clear;
Begin
   DeleteAll;
End;{* TCollection.Clear *}
{///////////////////////////////}
Function  TCollection.Limit;
Begin
  Limit := C_ItemMax;
End;{* TCollection.Limit *}
{///////////////////////////////}
Procedure TCollection.Pack;
Begin
End;{* TCollection.Pack *}
{///////////////////////////////}
Procedure TCollection.Error;
Begin
   Writeln ( 'Collection Error 212' );
   Halt ( 212 );
End;{* TCollection.Error *}
{///////////////////////////////}
Procedure TCollection.SetLimit;
Begin
   If ( ALimit < Count ) then ALimit := Count else
   If ( ALimit > MaxCollectionSize ) then ALimit := MaxCollectionSize;
   If ( ALimit <> Limit ) then begin
      C_ItemMax := ALimit;
      MemAlloc ( Items, Multi );
   end;
End;{* TCollection.SetLimit *}
{///////////////////////////////}
Procedure TCollection.FreeItem;
Begin
  If ( Item <> nil ) then Dispose ( pObject ( Item ), Done );
End;{* TCollection.FreeItem *}
{///////////////////////////////}
Function  TCollection.GetItem;
Begin
  GetItem := S.Get;
End;{* TCollection.GetItem *}
{///////////////////////////////}
Procedure TCollection.PutItem;
Begin
  S.Put ( Item );
End;{* TCollection.PutItem *}
{///////////////////////////////}
Procedure TCollection.Store;
Var
i : integer;
Begin
  S.Write ( I_Count, Sizeof ( Integer ) );
  for i := 1 to I_Count do PutItem ( S, Items^ [i] );
End;{* TCollection.Store *}
{///////////////////////////////}
Constructor TCollection.Load;
Var
i, j : Integer;
Begin
  TObject.Init;
  S.Read ( I_Count, Sizeof ( Integer ) );
  Items := nil;
  j := I_Count;
  I_Count := 0;
  Delta   := 1;
  C_ItemMax := j;
  MemAlloc ( Items, Multi );

  for i := 1 to j do begin
     AtPut ( i, GetItem ( S ) );
  end;
End;{* TCollection.Load *}
{///////////////////////////////}
{///////////////////////////////}
{//// TSORTEDCOLLECTION ////////}
{///////////////////////////////}
{///////////////////////////////}
Constructor TSortedCollection.Init;
Begin
   Inherited Init ( MaxNum, aDelta );
   Sorted := True;
   Name       := 'TSortedCollection';
End;{ * TSortedCollection.Init *}
{///////////////////////////////}
Constructor TSortedCollection.Create;
Begin
   Inherited Create ( MaxNum, aDelta );
   Sorted := True;
   Name       := 'TSortedCollection';
End;{ * TSortedCollection.Create *}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{//////// TSTRCOLLECTION ///////}
{///////////////////////////////}
{///////////////////////////////}
Function    TStrCollection.Less;
Begin
    Less := False;
    If ( Item1 = Nil ) or ( Item2 = Nil ) then exit;
    Less := StriComp ( pChar ( Item1 ), pChar ( Item2 ) ) < 0;
End;{* TStrCollection.Less *}
{///////////////////////////////}
Function    TStrCollection.Greater;
Begin
    Greater := False;
    If ( Item1 = Nil ) or ( Item2 = Nil ) then exit;
    Greater := StriComp ( pChar ( Item1 ), pChar ( Item2 ) ) > 0;
End;{* TStrCollection.Greater *}
{///////////////////////////////}
Function    TStrCollection.Equal;
Begin
    Equal := False;
    If ( Item1 = Nil ) or ( Item2 = Nil ) then exit;
    Equal := StriComp ( pChar ( Item1 ), pChar ( Item2 ) ) = 0;
End;{* TStrCollection.Equal *}
{///////////////////////////////}
Function    TStrCollection.Replace;
Begin
    Replace := False;
    If ( Index > C_ItemMax ) or ( Index < 1 ) then Exit;
    StrDispose ( Items^ [Index] );
    Item := Item + Chr ( 0 );
    Items^ [Index] := StrNew ( @Item [1] );
    Replace := True;
End;{* TStrCollection.Replace *}
{///////////////////////////////}
Function    TStrCollection.ReplacePChar;
Begin
    ReplacePChar := False;
    If ( Index > C_ItemMax ) or ( Index < 1 ) then Exit;
    StrDispose ( Items^ [Index] );
    Items^ [Index] := StrNew ( Item );
    ReplacePChar := True;
End;{* TStrCollection.ReplacePChar *}
{///////////////////////////////}
Function    TStrCollection.Add;
Begin
   Add := False;
   Item := Item + Chr ( 0 );
   Add := AtPut ( I_Count + 1, StrNew ( @Item [1] ) );
   If Sorted then SortAll;
End;{* TStrCollection.Add *}
{///////////////////////////////}
Function    TStrCollection.AddPChar;
Begin
   AddpChar := AtPut ( I_Count + 1, StrNew ( Item ) );
   If Sorted then SortAll;
End;{* TStrCollection.AddPChar *}
{///////////////////////////////}
Function    TStrCollection.RemoveItem;
Begin
    RemoveItem := False;
    If ( Index > C_ItemMax ) or ( Index < 1 )
    or ( Index > I_Count ) then Exit;
    StrDispose ( Items^ [Index] );
    RemoveItem := True;
End;{* TStrCollection.RemoveItem *}
{///////////////////////////////}
Destructor  TStrCollection.Destroy;
Var
i : Integer;
Begin
   for i := I_Count downto 1 do StrDispose ( Items^ [i] );
   Inherited Destroy;
End;{* TStrCollection.Destroy *}
{///////////////////////////////}
Destructor  TStrCollection.Done;
Var
i : Integer;
Begin
   for i := I_Count downto 1 do StrDispose ( Items^ [i] );
   Inherited Done;
End;{* TStrCollection.Done *}
{///////////////////////////////}
Procedure   TStrCollection.FreeItem;
Begin
  StrDispose ( pChar ( Item ) );
End;{* TStrCollection.FreeItem *}
{///////////////////////////////}
Function    TStrCollection.GetItem;
Begin
  GetItem := S.StrRead;
End;{* TStrCollection.GetItem *}
{///////////////////////////////}
Procedure   TStrCollection.PutItem;
Begin
  S.StrWrite ( pChar ( Item ) );
End;{* TStrCollection.PutItem *}
{///////////////////////////////}
Function    TStrCollection.Strings;
Begin
    Strings := '';
    If ( Index > C_ItemMax ) or ( Index < 1 )
    or ( Index > I_Count ) then Exit;

    If ( Items^ [Index] <> Nil )
    then Strings := StrPas ( pChar ( Items^ [Index] ) );
End;{* TStrCollection.Strings *}
{///////////////////////////////}
Function    TStrCollection.pChars;
Var
p : pChar;
Begin
    p^ := Chr ( 0 );
    pChars := p;
    If ( Index > C_ItemMax ) or ( Index < 1 )
    or ( Index > I_Count ) then Exit;

    If ( Items^ [Index] <> Nil )
    then p := pChar ( Items^ [Index] );

    pChars := p;
End;{* TStrCollection.pChars *}
{///////////////////////////////}
Function  TStrCollection.ReadFromFile;
Var
i : Integer;
OurFile : Text;
s : string;
Begin
   ReadFromFile := - 1;
   If Not ExistFile ( FName ) then Exit;
   Assign ( OurFile, FName );
   Reset ( OurFile );
   If Ioresult <> 0 then exit;
   i := 0;
   While not Eof ( OurFile ) do begin
       Readln ( OurFile, s );
       If ioresult <> 0 then begin
           Close ( OurFile ); if ioresult <> 0 then;
           Exit;
       end;
       Add ( s );
       inc ( i );
       If ( I_Count > C_ItemMax ) and ( Delta < 1 ) then Break;
   end;
   Close ( OurFile ); if ioresult <> 0 then;
   ReadFromFile := i;
End;{* TStrCollection.ReadFromFile *}
{///////////////////////////////}
Function  TStrCollection.WriteToFile;
Var
i : Integer;
OurFile : Text;
Begin
   WriteToFile := - 2;
   If I_Count < 1 then exit;
   WriteToFile := - 1;
   Assign ( OurFile, FName );
   Rewrite ( OurFile );
   If ioresult <> 0 then exit;
   for i := 1 to I_Count do begin
       Writeln ( OurFile, Strings ( i ) );
       If ioresult <> 0 then begin
           Close ( OurFile ); if ioresult <> 0 then;
           Exit;
       end;
   end;
   Close ( OurFile ); if ioresult <> 0 then;
   WriteToFile := i;
End;{* TStrCollection.WriteToFile *}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
   TO BEGIN do begin
      ObjectCount := - 1;      { start with -1: aList.SelfID = 0 }
      aList.Create ( Nil );
   end; { to begin }

   TO END do Begin
      aList.Free;
   end; { to end }

End.
