{//////////////////////////////////////////////////////////////////////////}
{//                                                                      //}
{//                STAT.H IMPORT UNIT for GPC                            //}
{//                                                                      //}
{//  v1.00 - by Dr Abimbola A. Olowofoyeku (The African Chief);          //}
{//                                                                      //}
{//  This package is released as part of the GNU Pascal project.         //}
{//                                                                      //}
{//  NOTE - SOME OF THE ROUTINES IN THIS UNIT MAY NOT WORK CORRECTLY.    //}
{//  TEST CAREFULLY AND USE WITH CARE !!!                                //}
{//                                                                      //}
{//  This library is a free library; you can redistribute and/or modify  //}
{//  it under the terms of the GNU Library General Public License,       //}
{//  version 2, as published by the Free Software Foundation.            //}
{//                                                                      //}
{//  This library is distributed in the hope that it will be useful,     //}
{//  but WITHOUT ANY WARRANTY; without even the implied warranty of      //}
{//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       //}
{//  GNU Library General Public License for more details.                //}
{//                                                                      //}
{//  You should have received a copy of the GNU Library General Public   //}
{//  License along with this library (see the file COPYING.LIB);         //}
{//  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,  //}
{//  Cambridge, MA 02139, USA.                                           //}
{//                                                                      //}
{//  v1.00, May 1997 - Dr A Olowofoyeku: laa12@keele.ac.uk               //}
{//  Homepage: http://ourworld.compuserve.com/homepages/African_Chief    //}
{//////////////////////////////////////////////////////////////////////////}
UNIT STATS;

INTERFACE

USES GPCTYPES;
{$W-}

Const S_ISUID = $80000000;
Const S_ISGID = $40000000;

Const S_IRUSR = 00400;
Const S_IRGRP = 00040;
Const S_IROTH = 00004;
Const S_IWUSR = 00200;
Const S_IWGRP = 00020;
Const S_IWOTH = 00002;
Const S_IXUSR = 00100;
Const S_IXGRP = 00010;
Const S_IXOTH = 00001;
Const S_IRWXU = 00700;
Const S_IRWXG = 00070;
Const S_IRWXO = 00007;

{$DEFINE __DJ_time_t}


Type _STAT = record
              st_atime : TIME_T;
              st_ctime : TIME_T;
              st_dev   : DEV_T;
              st_gid   : GID_T;
              st_ino   : INO_T;
              st_mode  : MODE_T;
              st_mtime : TIME_T;
              st_nlink : NLINK_T;
              st_size  : OFF_T;
              st_blksize : OFF_T;
              st_uid     : UID_T;
              st_rdev    : DEV_T;
{= unused }
            end {_STAT};


function chmod ( _path : PChar;
               _mode : MODE_T ) : Integer; C;

function fstat ( _fildes : Integer;
               Var _buf : _STAT ) : Integer; C;

function mkdir ( _path : PChar;
               _mode : MODE_T ) : Integer; C;

function mkfifo ( _path : PChar;
                _mode : MODE_T ) : Integer; C;

function STAT ( _path : PChar;
              Var _buf : _STAT ) : Integer; C;

function umask ( _cmask : MODE_T ) : MODE_T; C;

{+// POSIX.1 doesn't mention these at all */ }

Const S_IFMT = $f000;

Const S_IFREG = $0000;
Const S_IFBLK = $1000;
Const S_IFCHR = $2000;
Const S_IFDIR = $3000;
Const S_IFIFO = $4000;
Const S_IFFIFO = S_IFIFO;

Const S_IFLABEL = $5000;
{
Function S_ISLABEL (Var m) : Boolean;
Function S_ISBLK   (Var m) : Boolean;
Function S_ISCHR   (Var m) : Boolean;
Function S_ISDIR   (Var m) : Boolean;
Function S_ISFIFO  (Var m) : Boolean;
Function S_ISREG   (Var m) : Boolean;
}

procedure _fixpath ( x, y : PChar ); C;

function _get_magic ( x : PChar;
                    y : Integer ) : ShortWord; C;

function _is_executable ( x : PChar;
                        y : Integer;
                        z : PChar ) : Integer; C;

function mknod ( _path : PChar;
               _mode : MODE_T;
               _dev : DEV_T ) : Integer; C;

function _truename ( x : PChar;
                   y : PChar ) : PChar; C;

{+// Bit-mapped variable _djstat_flags describes what expensive }
{-f?_STAT() features our application needs. If you don't need a }
{-feature, set its bit in the variable. By default, all the }
{=bits are cleared (i.e., you get the most expensive code). }
Const _STAT_INODE      = 1; {/* should we bother getting inode numbers? */}
Const _STAT_EXEC_EXT   = 2; {/* get execute bits from file extension? */}
Const _STAT_EXEC_MAGIC = 4; {/* get execute bits from magic signature? */}
Const _STAT_DIRSIZE    = 8; {/* compute directory size? */}
Const _STAT_ROOT_TIME  = $10; {/* try to get root dir time stamp? */}
Const _STAT_WRITEBIT   = $20; {/* fstat() needs write bit? */}


{+// Bit-mapped variable _djstat_fail_bits describes which individual }
{-undocumented features f?_STAT() failed to use. To get a human- }
{=readable description of the bits, call _djstat_describe_lossage(). }
Const _STFAIL_SDA      = 1; {/* Get SDA call failed */}
Const _STFAIL_OSVER    = 2; {/* Unsupported DOS version */}
Const _STFAIL_BADSDA   = 4; {/* Bad pointer to SDA */}
Const _STFAIL_TRUENAME = 8; {/* _truename() failed */}
Const _STFAIL_HASH     = $10; {/* inode defaults to hashing */}
Const _STFAIL_LABEL    = $20; {/* Root dir, but no volume label */}
Const _STFAIL_DCOUNT   = $40; {/* dirent_count ridiculously large */}
Const _STFAIL_WRITEBIT = $80; {/* fstat() failed to get write access bit */}
Const _STFAIL_DEVNO    = $100; {/* fstat() failed to get device number */}
Const _STFAIL_BADSFT   = $200; {/* SFT entry found, but can't be trusted */}
Const _STFAIL_SFTIDX   = $400; {/* bad SFT index in JFT */}
Const _STFAIL_SFTNF    = $800; {/* file entry not found in SFT array */}


IMPLEMENTATION

(*
Function S_ISLABEL;
Begin
 S_ISLABEL := (integer(m) and $f000) = $5000);
End;
{/////////////////////}
Function S_ISBLK;
Begin
S_ISBLK := (integer(m) and $f000) = $1000);
End;
{/////////////////////}
Function S_ISCHR;
Begin
S_ISCHR := (integer(m) and $f000) = $2000);
End;
{/////////////////////}
Function S_ISDIR;
Begin
S_ISDIR:= (integer(m) and $f000) = $3000);
End;
{/////////////////////}
Function S_ISFIFO;
Begin
S_ISFIFO:= (integer(m) and $f000 = $4000);
End;
{/////////////////////}
Function S_ISREG;
Begin
S_ISREG := (integer(m) and $f000 = $0000);
End;
{/////////////////////}
*)
end.
