{//////////////////////////////////////////////////////////////////////////}
{//                                                                      //}
{//                STDLIB.H IMPORT UNIT for GPC                          //}
{//                                                                      //}
{//  v1.00 - by Dr Abimbola A. Olowofoyeku (The African Chief);          //}
{//                                                                      //}
{//  This package is released as part of the GNU Pascal project.         //}
{//                                                                      //}
{//  NOTE - SOME OF THE ROUTINES IN THIS UNIT MAY NOT WORK CORRECTLY.    //}
{//  TEST CAREFULLY AND USE WITH CARE !!!                                //}
{//                                                                      //}
{//  This library is a free library; you can redistribute and/or modify  //}
{//  it under the terms of the GNU Library General Public License,       //}
{//  version 2, as published by the Free Software Foundation.            //}
{//                                                                      //}
{//  This library is distributed in the hope that it will be useful,     //}
{//  but WITHOUT ANY WARRANTY; without even the implied warranty of      //}
{//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       //}
{//  GNU Library General Public License for more details.                //}
{//                                                                      //}
{//  You should have received a copy of the GNU Library General Public   //}
{//  License along with this library (see the file COPYING.LIB);         //}
{//  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,  //}
{//  Cambridge, MA 02139, USA.                                           //}
{//                                                                      //}
{//  v1.00, May 1997 - Dr A Olowofoyeku: laa12@keele.ac.uk               //}
{//  Homepage: http://ourworld.compuserve.com/homepages/African_Chief    //}
{//////////////////////////////////////////////////////////////////////////}
UNIT STDLIB;

INTERFACE

USES GPCTYPES;
{$W-}

Const EXIT_FAILURE = 1;
Const EXIT_SUCCESS = 0;
{Const MB_CUR_MAX = __dj_mb_cur_max;}
Const RAND_MAX = 2147483647;

Type Div_t = record
            quot : Integer;
            rem : Integer;
          end {div_t};


Type LDiv_t = record
            quot : LongInt;
            rem : LongInt;
          end {ldiv_t};

procedure abort;C;

function abs ( _i : Integer ) : Integer; C;

function atexit ( Procedure aProc ) : Integer; C;


function atof ( _s : PChar ) : Double; C;

function atoi ( _s : PChar ) : Integer; C;

function atol ( _s : PChar ) : LongInt; C;

procedure bsearch ( Const _key;
                   Const _base;
                  _nelem : SIZE_T;
                  _size : SIZE_T;
                  Function _ck ( p1, p2 : pointer ) : integer
                  );C;

procedure calloc ( _nelem : SIZE_T;
                 _size : SIZE_T ); C;

function _div ( _numer : Integer;
             _denom : Integer ) : DIV_T; AsmName 'div';

procedure exit ( status : integer ); C;

procedure free ( Var _ptr ); C;

function getenv ( _name : PChar ) : PChar; C;

function labs ( _i : LongInt ) : LongInt; C;

function ldiv ( _numer : LongInt;
              _denom : LongInt ) : LDIV_T; C;

procedure malloc ( _size : SIZE_T ); C;

function mblen ( _s : PChar;
               _n : SIZE_T ) : Integer; C;

{
function mbstowcs(Var _wcs: WCHAR_T;
                   _s: PChar;
                  _n: SIZE_T): SIZE_T; C;

function mbtowc(Var _pwc: WCHAR_T;
                 _s: PChar;
                _n: SIZE_T): Integer; C;

}procedure qsort ( Var _base;
                _nelem : SIZE_T;
                _size : SIZE_T;
                Function SortFunc ( Const p1;Const p2 ) : integer
                );C;

function rand : Integer; C;

Function realloc ( Var _ptr;
                  _size : SIZE_T ) : Pointer; C;

procedure srand ( _seed : Word ); C;

function strtod ( _s : PChar;
                Var _endptr : pChar ) : Double; C;

function strtol ( _s : PChar;
                Var _endptr : pChar;
                _base : Integer ) : LongInt; C;

function strtoul ( _s : PChar;
                 Var _endptr : pChar;
                 _base : Integer ) : LongWord; C;

function system ( _s : PChar ) : Integer; C;

{function wcstombs(_s: PChar;
                   _wcs: PWCHAR_T;
                  _n: SIZE_T): SIZE_T; C;

function wctomb(_s: PChar;
                _wchar: WCHAR_T): Integer; C;
}
Type
lldiv_t = record
            quot : LongInt;
            rem : LongInt;
          end {_3};


procedure alloca ( _size : SIZE_T ); C;

function _atold ( _s : PChar ) : Extended; C;

function atoll ( _s : PChar ) : LongInt; C;

procedure cfree ( Var _ptr ); C;

function getpass ( _prompt : PChar ) : PChar; C;

function getlongpass ( _prompt : PChar;
                     _buffer : PChar;
                     _max_len : Integer ) : Integer; C;

function itoa ( value : Integer;
              buffer : PChar;
              radix : Integer ) : PChar; C;

function llabs ( _i : Longint ) : LongInt; C;

function lldiv ( _numer : LongInt;
               _denom : LongInt ) : LLDIV_T; C;

function putenv ( _val : PChar ) : Integer; C;

function setenv ( _var : PChar;
                 _val : PChar;
                _replace : Integer ) : Integer; C;

function _strtold ( _s : PChar;
                  Var _endptr : pChar ) : Extended; C;

function strtoll ( _s : PChar;
                 Var _endptr : pChar;
                 _base : Integer ) : LongInt; C;

function strtoull ( _s : PChar;
                  Var _endptr : pChar;
                  _base : Integer ) : LongInt; C;

procedure swab ( Const from;
               Var _to;
               nbytes : Integer ); C;

{+// BSD Random Number Generator */ }

function initstate ( _seed : Word; 
                   _arg_state : PChar; 
                   _n : Integer ) : PChar; C;

function setstate ( _arg_state : PChar ) : PChar; C;

function random : LongInt; C;

function srandom ( _seed : Integer ) : Integer; C;

{+// These vary in expected prototype, so we just don't prototype them. }
{-void xfree(void *_ptr); }
{-void * xmalloc(size_t _size); }
{-void * xrealloc(void *ptr, size_t _size); }
{= }

Const __system_redirect     = $0001; {/* redirect internally */}
Const __system_call_cmdproc = $0002; {/* always call COMMAND/$SHELL */}
Const __system_use_shell    = $0004; {/* use $SHELL if set */}
Const __system_allow_multiple_cmds  = $0008; {/* allow `cmd1; cmd2; ...' */}
Const __system_allow_long_cmds      = $0010; {/* handle commands > 126 chars */}
Const __system_emulate_command      = $0020; {/* try to emulate the shell */}
Const __system_handle_null_commands = $1000; {/* ignore cmds with no effect */}
Const __system_ignore_chdir         = $2000; {/* make `cd' be a null command */}
Const __system_emulate_chdir        = $4000; {/* handle `cd' internally */}



function _shell_command ( _prog : PChar;
                         _cmdline : PChar ) : Integer; C;

function _is_unixy_shell ( _prog : PChar ) : Integer; C;

function _is_dos_shell ( _prog : PChar ) : Integer; C;

IMPLEMENTATION

End.
