{//////////////////////////////////////////////////////////////////////////}
{//                                                                      //}
{//               BORLAND COMPATIBLE "SYSTEM" UNIT for GPC               //}
{//                                                                      //}
{//  v1.00 - by Dr Abimbola A. Olowofoyeku (The African Chief);          //}
{//          some routines by Peter Gerwinski                            //}
{//                                                                      //}
{//  This package is released as part of the GNU Pascal project.         //}
{//  It is NOT YET 100% compatible with Borland Pascal; remaining        //}
{//  incompatibilities are marked with "!!!"; some things are missing    //}
{//  NOTE - SOME OF THE ROUTINES IN THIS UNIT MAY NOT WORK CORRECTLY.    //}
{//  TEST CAREFULLY AND USE WITH CARE.                                   //}
{//                                                                      //}
{//  This library is a free library; you can redistribute and/or modify  //}
{//  it under the terms of the GNU Library General Public License,       //}
{//  version 2, as published by the Free Software Foundation.            //}
{//                                                                      //}
{//  This library is distributed in the hope that it will be useful,     //}
{//  but WITHOUT ANY WARRANTY; without even the implied warranty of      //}
{//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       //}
{//  GNU Library General Public License for more details.                //}
{//                                                                      //}
{//  You should have received a copy of the GNU Library General Public   //}
{//  License along with this library (see the file COPYING.LIB);         //}
{//  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,  //}
{//  Cambridge, MA 02139, USA.                                           //}
{//                                                                      //}
{//  v1.00, May 1997 - Dr A Olowofoyeku: laa12@keele.ac.uk               //}
{//  Homepage: http://ourworld.compuserve.com/homepages/African_Chief    //}
{//////////////////////////////////////////////////////////////////////////}
UNIT SYSTEM;

INTERFACE
{$I SYSTEM.INC}

USES
GPCTYPES;

{!!! comment this out, to remove extra stuff from the interface section !!! }
{!!! but if you do so, note that some other units, e.g.,
     DOS,
     GPCUTIL, etc,
     will not compile !!! }

{$define __EXTRASYS__}   { !!! export some extra stuff !!! }

{.$define __UNIX__} { uncomment to declare as UNIX }


{$X+}    { use extended syntax }
{$W-}    { disable warnings }

Const
SysError = - 1; { global constant for Bad Error }

{ BP exit procedure variable }
{ !!! define your exit procedures only in units !!! }
Var
ExitProc : Pointer value nil;

Var
{ BP internal error variable - used for IoResult }
InOutRes : integer;

{ !!! BP file mode variable - not used !!! }
FileMode : integer;

{ returns all the command line arguments passed to the program }
CmdLine : pChar;


{ !!! other BP system variables - most of them do NOTHING !!! }
Var
ExitCode  : Integer Value 0;
ErrorAddr : Pointer Value Nil;
FreeList  : Pointer Value Nil;
HeapEnd   : Pointer Value Nil;
HeapError : Pointer Value Nil;
HeapOrg   : Pointer Value Nil;
HeapPtr   : Pointer Value Nil;

{ !!! C error variable - needed to obtain results of I/O operations !!! }
Var
ErrorNum : AsmName 'errno' integer;

{ !!! C file mode variable - required in this unit - for opening
  files using C functions !!! }
Var
FMode : AsmName '_fmode' integer;


{///////////////////////////////}
{////Peter's Functions /////////}
{///////////////////////////////}
{ !!! FillChar does not accept Byte values as the last parameter. }
Procedure FillChar ( Var Dest : Void; Count : Integer; C : Char );

Procedure Move ( Var Source, Dest : Void; Count : Integer );

{ bind a filename to an external file }
Procedure Assign ( Var T : Text; Const Name : String );

{ Command line parameters, system environment }
Function  ParamCount : Integer;

{ return command line argument "i" }
Function  ParamStr ( i : Integer ) : String;

{ Random numbers }
{ Return a random Real number 0 <= x < 1 }
Function  Random : Real;

{ Return a random Integer number 0 <= x < limit }
Function  RandInt ( limit : Integer ) : Integer;

{ !!! A Unit cannot (yet;) provide both     }
{ "Function Random ( i: Integer ): Integer" }
{ and "Function Random: Real", so use two   }
{ functions instead.                        }

{ Initialize random number generator *}
Procedure InitRandom ( Seed : Integer ); asmname 'srand';
{ !!! There is no RandSeed variable, so use this as a workaround. *}
{////////////////////////////////}
{//// Peter's Functions end /////}
{////////////////////////////////}
{////////////////////////////////}

{ generate a runtime error }
Procedure RunError ( ErrorCode : Integer );

{ !!! ioresult function - not yet completed !!! }
Function  Ioresult : Integer;

{ !!! dummy function - always returns zero !!! }
Function  MemAvail : Integer;

{ !!! dummy function - always returns zero !!! }
Function  MaxAvail : Integer;

{ find out whether p is assigned (i.e, <> NIL) }
Function  Assigned ( P : Pointer ) : Boolean;

{ return the address of X }
Function  Addr     ( Var X ) : Pointer;

{ convert a char to uppercase }
Function  UpCase ( c : Char ) : Char; AsmName 'toupper';

{ convert a char to lowercase }
Function  LoCase ( c : Char ) : Char; AsmName 'tolower';

{ convert integer "i" to string "s";
  !!! not portable to unix, because it uses
  itoa() (which does not exist in unix ??) !!!}
Procedure Str ( i : integer; Var s : string );

{ convert a string value to its numeric representation
  -  returns numeric value in Dest = otherwise return
  in ErrCode the point where the first non-numeric character
  was found;
  !!! does not work for real types  !!!}
Procedure Val ( S : string; var Dest; var ErrCode : Integer );

{ !!! convert string to a real type !!! }
Procedure ValReal ( S : string; var Dest : Double; var ErrCode : Integer );

{ return position of "sub", in "s" }
Function  Pos ( sub : string; s : string ) : integer;

{ copy "count" characters from "s", starting at "start" }
Function  Copy ( Const s : string;start, count : integer ) : string;

{ delete "count" characters from "s", starting at "start" }
Procedure Delete ( Var s : string;start, count : integer );

{ insert "Src" into "Dest" at the indexth position }
Procedure Insert ( Const Src : String; var Dest : String; Index : Integer );

{ return the integer part of X }
Function  Int ( X : Real ) : Real;

{ return the fractional part X }
Function  Frac ( X : Real ) : Real;

{///////////////////////////////}
{///////////////////////////////}
{//////  File I/O stuff     ////}
{///////////////////////////////}
{///////////////////////////////}
{ return location of file pointer }
Function FilePos ( Handle : Integer ) : OFF_T; AsmName 'tell';

{ go to position "location" in a file }
Function Seek ( Handle : integer; Location : longint ) : longint;

{ create a file }
Function CreateFile ( Fname : string ) : integer;

{ open a file }
Function OpenFile   ( Fname : string ) : integer;

{ close a file }
Function CloseFile  ( Handle : integer ) : integer;AsmName 'close';

{ truncate a file - not portable }
Function TruncateFile ( Handle : integer; Size : integer ) : integer;
AsmName 'ftruncate';

{ return the size of the file }
Function FileSize ( Handle : Integer ) : integer;
{AsmName 'filelength';}

{ read from a file into "buf" }
Function ReadFile   ( Handle : integer;Var Buf;Count : integer ) : integer;
AsmName 'read';

{ write "buf" into a file }
Function WriteFile  ( Handle : integer;Var Buf;Count : integer ) : integer;
AsmName 'write';

{///////////////////////////////}
{////// other file routines ////}
{///////////////////////////////}
{ main file record type ( BinFile = TFileRec ) }
Type
tFileInt  = integer {value -100};
tFileLong = longint {value -100};

Type
 TFileRec = packed record
    Handle  : tFileInt;   {* file handle *}
    Mode    : tFileInt;   {* file mode *}
    Size    : tFileInt;   {* file size *}
    Name    : String [255]; {* file name *}
    Reserved : Array [1..8] of integer; {* reserved *}
  end; {* TFileRec *}

Type
  BinFile = TFileRec;

{ !!! change _fmode value - but return the current value first
  (whether it is in binary mode) = which is the default }
Function SetFMode ( Binary : Boolean ) : Boolean;

{ !!! return real value of FMode}
Function GetFMode : integer;

{ file functions using file record type - instead of
  integer file handles }

{ is the file "F" assigned? }
Function  IsBinAssigned ( Var F : BinFile ) : Boolean;
AsmName '_p_isbinassigned';

{ is the file "F" Open? }
Function  IsBinOpened ( Var F : BinFile ) : Boolean;
AsmName '_p_isbinopened';

{ assign name to a file record }
Function  BinAssign ( Var F : BinFile; Const aName : String ) : Boolean;
AsmName '_p_binassign';

{ close the file }
Function  BinClose ( Var F : BinFile ) : Boolean;
AsmName '_p_binclose';

{ open the file }
Function  BinReset ( Var F : BinFile ) : Boolean;
AsmName '_p_binreset';

{ create or overwrite the file }
Function  BinReWrite ( Var F : BinFile ) : Boolean;
AsmName '_p_binrewrite';

{ delete a file "F" - it must already be assigned, but not open }
Function  BinErase ( Var F : BinFile ) : Boolean;
AsmName '_p_binerase';

{ rename a file "F" - it must already be assigned, but not open }
Function  BinRename ( Var F : BinFile; NewName : String ) : Boolean;
AsmName '_p_binrename';

{ truncate a file }
Function  BinTruncate ( Var F : BinFile; Size : integer ) : Boolean;
AsmName '_p_bintruncate';

{ reached the end of file? }
Function  BinEof ( Var F : BinFile ) : boolean;
AsmName '_p_bineof';

{ return the current position in the file }
Function  BinFilePos ( Var F : BinFile ) : Integer;
AsmName '_p_binfilepos';

{ goto location in file }
Function  BinSeek ( Var F : BinFile ; Location : longint ) : boolean;
AsmName '_p_binseek';

{ return the size of F }
Function  BinFileSize ( Var F : BinFile ) : Integer;
AsmName '_p_binfilesize';

{ read a block of "Count" bytes from "F" into "Buf" }
Procedure BlockRead ( var F : BinFile; var Buf; Count : integer;
var aResult : integer );
AsmName '_p_blockread';

{ write a block of "Count" bytes from "Buf" into "F" }
Procedure BlockWrite ( var F : BinFile; var Buf; Count : integer;
var aResult : integer );
AsmName '_p_blockwrite';
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}

{$ifdef __EXTRASYS__}
{ !!!! EXTRA FUNCTIONS, and stuff !!!!!! }

{$ifdef __UNIX__}
Const
  PathSeparator : Char = '/';
{$else __UNIX__}
Const
  PathSeparator : Char = '\';
{$endif __UNIX__}

{ change frontslash to backslash;
  no change if "__UNIX__" is defined }
Function  ChangeFrontSlash ( s : string ) : string;

{ change frontslash to backslash; using a pChar
  no change if "__UNIX__" is defined }
Function  ChangeFrontSlashPChar ( p : pChar ) : pChar;

{ !!!  convert Pascal string to pchar }
Function  Str2pChar ( Var s : String ) : pChar;

{ !!!! EXTRA FUNCTIONS and stuff END !!!!!! }

{$endif __EXTRASYS__}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{ !!! helper functions from C library  - needed in this unit !!! }
Type
FileSTAT = record
              st_atime : TIME_T;
              st_ctime : TIME_T;
              st_dev   : DEV_T;
              st_gid   : GID_T;
              st_ino   : INO_T;
              st_mode  : MODE_T;
              st_mtime : TIME_T;
              st_nlink : NLINK_T;
              st_size  : OFF_T;
              st_blksize : OFF_T;
              st_uid     : UID_T;
              st_rdev    : DEV_T;
end {FileSTAT};

function FStat ( handle : Integer; Var buf : FileSTAT ) : Integer; C;

IMPLEMENTATION
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
Var
Junk: integer;  { junk variable to use for various things }

{ helper functions from C library }
Function  StrPos  ( Str, SubStr : pChar ) : pChar;AsmName 'strstr';
Function  StrCopy ( Dest, Src : PChar ) : pChar;AsmName 'strcpy';
function  l_itoa ( value : integer;buffer : PChar;radix : Integer ) : PChar; AsmName 'itoa';
Function  pChar2Int ( s : PChar ) : Longint; AsmName 'atol';
Function  pChar2Double ( s : PChar ) : Double; AsmName 'atof';
Function  remove_f ( filename : PChar ) : Integer; AsmName 'remove';
Function  rename_f ( fold : PChar; fnew : PChar ) : Integer; AsmName 'rename';

function l_creatp ( path : PChar;  {portable}attrib : Integer ) :
Integer; AsmName 'creat';

function l_openp ( path : PChar; { portable } oflag, mode : Integer ) : Integer;
AsmName 'open';

Function lseek ( Handle : Integer; offset : OFF_T; origin : Integer )
: OFF_T; C;
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
function StrPas ( Src : pChar ) : String;
var
S : String;
begin
   S := '';
   if ( Src <> NIL )
   then while ( ( Src^ <> chr ( 0 ) ) AND ( length ( S ) < S.capacity ) )
   do begin
      S := S + Src^;
      inc ( Src );
   end;
   StrPas := S;
end; {* strpas *}
{///////////////////////////////}
Function  Assigned ( P : Pointer ) : Boolean;
Begin
  Assigned := ( P <> Nil );
End; {* Assigned *}
{///////////////////////////////}
Function  Addr ( Var X ) : Pointer;
Begin
  Addr := ( @X );
End; {* Addr *}
{///////////////////////////////}
Function  Copy ( Const s : string;start, count : integer ) : string;
Var
s1 : string;
i, j : integer;
Begin
   s1 := '';
   Copy := '';
   if  ( s <> '' ) and ( count > 0 ) or ( start > 0 )
   and ( start <= length ( s ) )
   then begin
     j := start + count;
     i := length ( s ) + 1;
     if j > i then j := i;
     for i := start to pred ( j ) do
     s1 := s1 + s [i];
     Copy := s1;
  end;
(*
   Copy := SubStr ( s, start, count ); { !!! Extended Pascal routine !!! }
*)
End;{* Copy *}
{/////////////////////////}
Function Pos ( sub : string; s : string ) : integer;
Begin
  Pos := Index ( s, sub ); { !!! Extended Pascal routine !!! }
End;{* Pos *}
{///////////////////////////////}
Procedure Delete ( Var s : string; start, count : integer );
Var
s1 : string;
i, j : integer;
Begin
    If ( s <> '' ) and ( start > 0 ) and ( count > 0 )
    then begin
      j := start + count;
      s1 := '';
      for i := 1 to length ( s )
      do begin
        if ( i >= start ) and ( i < j )  then {ignore it}
        else s1 := s1 + s [i];
      end;
      s := s1;
    end;
End;{* Delete *}
{///////////////////////////////}
{ Insert Src into Dest at the Indexth position }
Procedure Insert ( Const Src : String; var Dest : String; Index : Integer );
Var
s1 : string;
i, j : integer;
Begin
   j := length ( Dest );
   If ( Src = '' ) or ( Index < 1 ) or ( Index > j ) then exit;

   {copy to pred(index)}
   s1 := '';
   for i := 1 to Pred ( Index ) do
   s1 := s1 + Dest [i];

   {add Src}
   s1 := s1 + Src;

   {add the rest of dest}
   for i := Index to j do
   s1 := s1 + Dest [i];

   {return the end result}
   Dest := s1;
End; {* Insert *}
{///////////////////////////////}
Function Int2pChar ( i : integer ) : pChar;
Var
p : pChar;
Begin
  getmem ( p, 55 );
  p := l_itoa ( i, p, 10 );
  Int2PChar := p;
  freemem ( p, 55 );
End; {* int2pchar *}
{///////////////////////////}
Procedure Str ( i : integer; Var s : string );
Begin
  s := Strpas ( Int2pChar ( i ) );
End;{* Str *}
{///////////////////////////}
Procedure Val ( S : string; var Dest; var ErrCode : Integer );
Var
i : integer;
p : pLongint;
Begin
   { check for non-numeric values}
   for i := 1 to length ( s ) do
   if s [i] in ['0' .. '9', '-']
   then {} else begin
      ErrCode := i;
      exit;
   end;
   ErrCode := 0;
   s := s + chr ( 0 );
   p := @Dest;
   p^ := pChar2Int ( @s [1] );
end;{* Val *}
{///////////////////////////////}
Procedure ValReal ( S : string; var Dest : Double; var ErrCode : Integer );
Var
i : integer;
Begin
   { check for non-numeric values}
   for i := 1 to length ( s ) do
   if s [i] in ['0' .. '9', '.', '-']
   then {} else begin
      ErrCode := i;
      exit;
   end;
   ErrCode := 0;
   s := s + chr ( 0 );
   Dest := pChar2Double ( @s [1] );
end;{* ValReal *}
{///////////////////////////////}
Function  Ioresult : Integer;
Begin
   IoResult := InOutRes;
   InOutRes := 0;
End; {* IoResult *}
{///////////////////////////////}
Function Seek ( Handle : integer; Location : longint ) : longint;
Begin
   Junk := lseek ( Handle, Location, 0 ); {seek from beginning of file}
   Seek := Junk;
   If ( Junk = SysError )
   then InOutRes := ErrorNum
   else InOutRes := 0;
End;{* Seek *}
{///////////////////////////}
Function CreateFile ( Fname : string ) : integer;
Begin
   Fname := Fname + Chr ( 0 );
   Junk := l_creatp ( @Fname [1], L_IWRITE or L_IREAD );
   CreateFile := Junk;
   If ( Junk = SysError )
   then InOutRes := ErrorNum
   else InOutRes := 0;
End;{* CreateFile *}
{///////////////////////////}
Function Open_ ( path : pChar; access, shflag, mode : integer ) : integer;
Begin
   Junk := l_openP ( path, ( ( access ) or ( shflag ) ), mode );
   Open_ := Junk;
   If ( Junk = SysError )
   then InOutRes := ErrorNum
   else InOutRes := 0;
End; {* Open_ *}
{///////////////////////////////}
Function OpenFile   ( Fname : string ) : integer;
Begin
   Fname := Fname + Chr ( 0 );
   Junk  := l_openP
            ( @Fname [1],
            ( ( L_READWRITE or L_BINARY ) or ( LSH_DENYNO ) ),
            ( L_IREAD or L_IWRITE ) );
   OpenFile := Junk;
   If ( Junk = SysError )
   then InOutRes := ErrorNum
   else InOutRes := 0;
End;{* OpenFile *}
{///////////////////////////////}
Function FileSize ( Handle : Integer ) : integer;
Var
f : FileSTAT;
Begin
   Junk := fstat ( handle, f );
   if Junk = 0
   then FileSize := f.st_size
   else FileSize := SysError;

   If ( Junk = SysError )
   then InOutRes := ErrorNum
   else InOutRes := 0;
End;{* FileSize *}
{///////////////////////////////}
Function IsBinAssigned ( Var F : BinFile ) : Boolean;
Begin
   With F do begin
      IsBinAssigned :=
      ( Name <> '' )  and
      ( Reserved [1] = - 88 ) and
      ( Reserved [2] = - 78 ) and
      ( Reserved [3] = - 68 ) and
      ( Reserved [8] = - 18 );
   end;
End; {* IsBinAssigned *}
{///////////////////////////////}
Function IsBinOpened ( Var F : BinFile ) : Boolean;
Begin
   With F do begin
       IsBinOpened :=
       ( IsBinAssigned ( F ) ) and
       ( Handle >= 0 ) and
       ( Mode = $0002 );
   end;
End; {* IsBinOpened *}
{///////////////////////////////}
Function BinAssign ( Var F : BinFile; Const aName : String ) : Boolean;
Begin
   BinAssign := False;
   InOutRes := SysError;
   If aName <> '' then
   With F do begin
	Name := aName{ + Chr (0)};
	Mode := 200;
	Size := SysError;
	Handle  := - 200;
   	BinAssign := True;
        Reserved [1] := - 88;
        Reserved [2] := - 78;
        Reserved [3] := - 68;
        Reserved [8] := - 18;
        InOutRes := 0;
   end;
End;{* BinAssign *}
{///////////////////////////////}
Function BinClose ( Var F : BinFile ) : Boolean;
Begin
    BinClose := False;
    InOutRes := SysError;
    With F do begin
        { not assigned? }
        If ( Handle < 1 ) or ( Name = '' ) then {Exit;}
        else begin
           Mode := CloseFile ( Handle );
           BinClose := ( Mode <> SysError );

           If ( Mode <> SysError )
           then InOutRes := 0
           else InOutRes := ErrorNum;

	   Name    := '';
	   Size    := SysError;
	   Handle  := SysError;
	   Mode    := SysError;
           Reserved [1] := SysError;
           Reserved [2] := SysError;
           Reserved [3] := SysError;
           Reserved [8] := SysError;
	end;
   end;
End; {* BinClose *}
{///////////////////////////////}
Function BinReset ( Var F : BinFile ) : Boolean;
Begin
   BinReset := False;
   InOutRes := SysError;
   With F do begin
        If  ( Name = '' ) then {Exit;}
        else
        { already open - go back to beginning }
        If ( Handle >= 0 ) and ( Mode = $0002 )
        then begin
           BinReset := integer ( Seek ( Handle, 0 ) ) >= 0;
           {exit;}
        end
        else begin
           Handle := OpenFile ( Name );
           Size   := FileSize ( Handle );
           BinReset := Handle >= 0;
           Mode := $0002; { read/write}
        end;

      If ( Handle = SysError )
      then InOutRes := ErrorNum
      else InOutRes := 0;
   end;
End;{* BinReset *}
{///////////////////////////////}
Function BinReWrite ( Var F : BinFile ) : Boolean;
Begin
   BinReWrite := False;
   InOutRes   := SysError;
   With F do begin
       If  ( Name = '' ) then Exit;
        { already open - go exit }
        If ( Handle >= 0 ) and ( Mode = $0002 )
        then begin
           exit;
        end;

	Handle := CreateFile ( Name );
        Size   := 0;
        BinReWrite := Handle >= 0;
        Mode := $0002; { read/write}

        If ( Handle = SysError )
        then InOutRes := ErrorNum
        else InOutRes := 0;
   end;
End;{* BinReWrite *}
{///////////////////////////////}
Function BinErase ( Var F : BinFile ) : Boolean;
Begin
  InOutRes := SysError;
  Junk     := SysError;
  With F do begin
     If  ( IsBinAssigned ( F ) )
     and ( NOT IsBinOpened ( F ) )
     then Junk := remove_f ( Str2pChar ( Name ) );

     BinErase := ( Junk <> SysError );

     If ( Junk = SysError )
     then InOutRes := Junk
     else InOutRes := 0;
  end; {* with F *}
End; {* BinErase *}
{///////////////////////////////}
Function BinRename ( Var F : BinFile; NewName : String ) : Boolean;
Begin
  InOutRes  := SysError;
  Junk      := SysError;
  With F do begin
     If  ( IsBinAssigned ( F ) )
     and ( NOT IsBinOpened ( F ) )
     then Junk := rename_f ( Str2pChar ( Name ), Str2pChar ( NewName ) );

     BinRename := ( Junk <> SysError );

     If ( Junk = SysError )
     then InOutRes := Junk
     else InOutRes := 0;
  end; {* with F *}
End; {* BinRename *}
{///////////////////////////////}
Function BinTruncate ( Var F : BinFile; Size : integer ) : Boolean;
Begin
    BinTruncate := False;
    InOutRes    := SysError;

    With F do begin
      If  ( Name = '' ) then Exit;

      Junk := TruncateFile ( Handle, Size );

      BinTruncate := ( Junk <> SysError );

      If ( Junk = SysError )
      then InOutRes := ErrorNum
      else InOutRes := 0;

    end;
End;{* BinTruncate *}
{///////////////////////////////}
Function  BinFilePos ( Var F : BinFile ) : Integer;
Begin
   With F do begin

      If Name = '' then begin
         BinFilePos := SysError;
         InOutRes := SysError;
         Exit;
      end;

      Junk := FilePos ( Handle );
      BinFilePos := Junk;

      If ( Junk = SysError )
      then InOutRes := ErrorNum
      else InOutRes := 0;
   end;
End;{* BinFilePos *}
{///////////////////////////////}
Function BinEof ( Var F : BinFile ) : boolean;
Begin
   With F do begin
      If Name = '' then begin
         BinEof := True;
         InOutRes := SysError;
         Exit;
      end;

      Junk := FilePos ( Handle );

      If ( Junk = SysError )
      then begin
         InOutRes := ErrorNum;
         BinEof := True;
      end
      else begin
         InOutRes = 0;
         BinEof :=  Junk >= Integer ( Size );
      end;
   end; { With F }
End;{* BinEof *}
{///////////////////////////////}
Function  BinSeek ( Var F : BinFile ; Location : longint ) : boolean;
Begin
   BinSeek := False;
   If NOT IsBinOpened ( F ) then begin
     InOutRes := SysError;
     Exit;
   end;

   With F do begin
      BinSeek := Integer ( Seek ( Handle, Location ) ) >= 0;
   end;
End;{* BinSeek *}
{///////////////////////////////}
Function BinFileSize ( Var F : BinFile ) : Integer;
Begin
    BinFileSize := SysError;

    With F do begin
       If ( Handle < 1 ) or ( Name = '' ) then InOutRes := SysError
       else begin
          BinFileSize := Size;
          InOutRes := 0;
       end;
    end;
End;{ * BinFileSize *}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
Procedure BlockRead ( var F : BinFile; var Buf; Count : integer;
var aResult : integer );
Begin
   With F do begin
     aResult := ReadFile ( Handle, Buf, Count );
     If aResult >= 0
     then InOutRes := 0
     else InOutRes := ErrorNum;
   end;
End;{* BlockRead *}
{///////////////////////////////}
Procedure BlockWrite ( var F : BinFile; var Buf; Count : integer;
var aResult : integer );
Begin
   With F do begin
      aResult := WriteFile ( Handle, Buf, Count );
      Size := Size + aResult;
      If aResult >= 0
      then InOutRes := 0 else
      InOutRes := ErrorNum;
   end;
End;{* BlockWrite *}
{///////////////////////////////}
Function Int ( X : Real ) : Real;
Var
i : longint;
Begin
  i := longint ( X );
  Int := i;
End;{* Int *}
{///////////////////////////////}
Function  Frac ( X : Real ) : Real;
Begin
  Frac := X - Int ( X );
End;{* Frac *}
{///////////////////////////////}
Procedure RunError ( ErrorCode : Integer );
Begin
  Writeln ( 'Runtime error: ', ErrorCode );
  Halt ( ErrorCode );
End;
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}

{///////////////////////////////}
{///////////////////////////////}
{/// Peter's Functions begin ///}
{///////////////////////////////}
{///////////////////////////////}
Procedure FillChar ( Var Dest : Void; Count : Integer; C : Char );
Type
  BytePtr = ^Byte;
Var
  p, q : BytePtr;
begin {* FillChar *}
  p := @Dest;
  q := BytePtr ( LongInt ( p ) + Count );
  while LongInt ( p ) < LongInt ( q ) do
    begin
      p^ := ord ( C );
      inc ( LongInt ( p ) );
    end {* while *};
end {* FillChar *};
{///////////////////////////////}
Procedure Move ( Var Source, Dest : Void; Count : Integer );
Type
  BytePtr = ^Byte;
Var
  p, q, r : BytePtr;
begin {* Move *}
  p := @Source;
  q := @Dest;
  if LongInt ( q ) > LongInt ( p ) then
    begin
      {* Avoid overwriting of overlapping memory areas *}
      r := p;
      p := BytePtr ( LongInt ( p ) + Count );
      q := BytePtr ( LongInt ( q ) + Count );
      while LongInt ( p ) > LongInt ( r ) do
        begin
          dec ( p );
          dec ( q );
          q^ := p^;
        end {* while *};
    end {* if *}
  else
    begin
      r := BytePtr ( LongInt ( p ) + Count );
      while LongInt ( p ) < LongInt ( r ) do
        begin
          q^ := p^;
          inc ( p );
          inc ( q );
        end {* while *};
    end {* else *};
end {* Move *};
{///////////////////////////////}
{* Use the GPC run-time-system's ParamCount and ParamStr function *}
Function rtsParamCount : Integer;
AsmName '_p_paramcount';

Function rtsParamStr ( i : Integer; Var S : String ) : Boolean;
AsmName '_p_paramstr';

Function ParamCount : Integer;  {* This is stupid. *}
begin {* ParamCount *}
  ParamCount := rtsParamCount - 1;
end {* ParamCount *};
{///////////////////////////////}
Function ParamStr ( i : Integer ) : String;
Var
  S : String;
begin {* ParamStr *}
  if rtsParamStr ( i, S )
  then begin
    S := Trim ( S );
    { !!! ParamStr ( 0 ) - change front to backslash !!! }
    If ( i = 0 ) then S := ChangeFrontSlash ( S );
    ParamStr := S;
  end
  else
    ParamStr := '';
end {* ParamStr *};
{///////////////////////////////}
Procedure Assign ( Var T : Text; Const Name : String );
Var
  B : BindingType;
Begin {* Assign *}
  If Name = ''
  then InOutRes := 2
  else InOutRes := 0;

  unbind ( T );
  B := binding ( T );
  B.Name := ChangeFrontSlash ( Name );
  bind ( T, B );
  B := binding ( T );
End {* Assign *};
{///////////////////////////////}
Function CRandom : Integer;
AsmName 'rand';

Function RandInt ( limit : Integer ) : Integer;
begin {* RandInt *}
  RandInt := CRandom mod limit;
end {* RandInt *};
{///////////////////////////////}
Function Random : Real;
begin {* Random *}
  Random := CRandom / $7FFFFFFF;
end {* Random *};
{///////////////////////////////}
{///////////////////////////////}
{////Peter's Functions end /////}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{$ifndef __UNIX__}
{ DPMI memory stuff - not used in unix }
Type
DpmiFreeInfo = Record
   largest_available_free_block_in_bytes : Word;
   maximum_unlocked_page_allocation_in_pages : Word;
   maximum_locked_page_allocation_in_pages : Word;
   linear_address_space_size_in_pages : Word;
   total_number_of_unlocked_pages : Word;
   total_number_of_free_pages : Word;
   total_number_of_physical_pages : Word;
   free_linear_address_space_in_pages : Word;
   size_of_paging_file_partition_in_pages : Word;
   reserved : Array [0..2] of Word;
End {DpmiFreeInfo};

Function  GetFreeDpmiMemInfo ( Var info : DpmiFreeInfo ) : Integer;
AsmName '__dpmi_get_free_memory_information';

function __dpmi_get_page_size ( Var _size : Word ) : Integer; C;
{$endif __UNIX__}


Function MemAvail : Integer;
{$ifndef __UNIX__}
Var
D : DpmiFreeInfo;
W : Word;
{$endif}
Begin
  {$ifdef __UNIX__}
    MemAvail := 0;
  {$else __UNIX__}
    GetFreeDpmiMemInfo ( D );
    __dpmi_get_page_size ( W );
    MemAvail := ( D.total_number_of_unlocked_pages * W )
  {$endif __UNIX__}
End;{* MemAvail *}
{///////////////////////////////}
Function MaxAvail : Integer;
{$ifndef __UNIX__}
Var
D : DpmiFreeInfo;
W : Word;
{$endif}
Begin
  {$ifdef __UNIX__}
    MaxAvail := 0;
  {$else __UNIX__}
    GetFreeDpmiMemInfo ( D );
    __dpmi_get_page_size ( W );
    MaxAvail := ( D.total_number_of_free_pages * W )
  {$endif __UNIX__}
End;{* MaxAvail *}
{///////////////////////////////}
Function SetFMode ( Binary : Boolean ) : Boolean;
Begin
   SetFmode := ( FMode = L_BINARY );  { return the current value }
   If Binary
   then FMode := L_BINARY  { change to the new value }
   else Fmode := L_TEXT;
End;{*  SetFMode *}
{///////////////////////////////}
Function GetFMode : integer;
Begin
   GetFMode := FMode;
End;{* GetFMode *}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{//     __EXTRASYS__ stuff    //}
Function Str2pChar ( Var s : String ) : pChar;
Var
x : String;
Begin
  x := s;
  s := s + Chr ( 0 );
  Str2pChar := @s [1];
  s := x;
End; {* str2pChar *}
{///////////////////////////////}
Function ChangeFrontSlash ( s : string ) : string;
Var
i : integer;
Begin
  {$ifndef __UNIX__}
   for i := 1 to length ( s ) do
   if s [i] = '/' then
      s [i] := '\';
  {$endif __UNIX__}
   ChangeFrontSlash := s;
End; {* ChangeFrontSlash *}
{///////////////////////////////}
Function ChangeFrontSlashPChar ( p : pChar ) : pChar;
Var
i : integer;
s : string;
Begin
   s := ChangeFrontSlash ( strpas ( p ) ) + chr ( 0 );
   ChangeFrontSlashPChar := strcopy ( p, @s [1] );
End; {* ChangeFrontSlashPChar *}
{//  __EXTRASYS__ stuff ends  //}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
Var
ppJunk : ^String1024; { Junk string variable }

  To BEGIN do begin               { EP initialisation style }
       FMode    := L_BINARY;      { default to binary }
       InOutRes := 0;             { ! }
       FileMode := L_READWRITE;   { default to read/write access }

       { store the command line in CmdLine }
       New ( ppJunk );
       ppJunk^ := '';

       If ParamCount = 0 then ppJunk^ := Chr ( 0 )
       else begin
          For Junk := 1 to ParamCount
          do ppJunk^ := ppJunk^ + ParamStr ( Junk ) + ' ';

          ppJunk^ [Length ( ppJunk^ )] := Chr ( 0 );
       end;

       CmdLine := @ppJunk^ [1];
       Dispose ( ppJunk );
  end; { TO BEGIN do }

  TO END do begin               { EP finalisation style }
     while ( ExitProc <> Nil ) do pProcedure ( ExitProc ) ^;
  end; { TO END do }

End.
