{//////////////////////////////////////////////////////////////////////////}
{//                                                                      //}
{//   TEST PROGRAM for GPC - TESTS THE COLLECTIONS IN THE OBJECTS UNIT   //}
{//                                                                      //}
{//         By Dr Abimbola A. Olowofoyeku (The African Chief);           //}
{//                                                                      //}
{//  This test program is released as part of the GNU Pascal project,    //}
{//  for the SOLE purpose of testing the routines in certain units.      //}
{//                                                                      //}
{//  This program is a free program; you can redistribute and/or modify  //}
{//  it under the terms of the GNU Library General Public License,       //}
{//  version 2, as published by the Free Software Foundation.            //}
{//                                                                      //}
{//  This library is distributed in the hope that it will be useful,     //}
{//  but WITHOUT ANY WARRANTY; without even the implied warranty of      //}
{//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       //}
{//  GNU Library General Public License for more details.                //}
{//                                                                      //}
{//  You should have received a copy of the GNU Library General Public   //}
{//  License along with this library (see the file COPYING.LIB);         //}
{//  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,  //}
{//  Cambridge, MA 02139, USA.                                           //}
{//                                                                      //}
{//  May 1997 - Dr A Olowofoyeku: laa12@keele.ac.uk                      //}
{//  Homepage: http://ourworld.compuserve.com/homepages/African_Chief    //}
{//////////////////////////////////////////////////////////////////////////}
PROGRAM TestColl;

USES
GPCTYPES, SYSTEM, STRINGS, OBJECTS;

{$X+}
{$W-}

Var
aCount : integer;

{ callback Function for collection }
Function Xat ( p : pointer ) : Boolean;
Var
x : pChar;
Begin
  x := pChar ( p );
  Inc ( aCount );
  Writeln ( aCount, '.', StrPas ( x ) );
  Xat := True;
End;{* Xat *}

{ program() }
Var
i     : integer;
c     : TStrCollection;
t     : TDosStream;
f     : ForEachProc;
s     : string;

Begin
  WRITELN ( '-------------------------------' );
  aCount := 0;

  c.Init ( 1024, 24 );
  With c do Begin
    Duplicates := FALSE;
    Sorted := TRUE;
    Add ( 'Peter Gerwinski' );
    Add ( 'Abimbola Adeleke Olowofoyeku' );
    Add ( 'African Chief' );
    Add ( 'Abimbola' );
    Add ( 'Zenobia' );
    Add ( 'Great Elephant' );
    Add ( 'Abimbola Adeleke' );
    Add ( 'The Great Chief and Elephant' );
    Add ( 'Abimbola Adeleke Olowofoyeku' );
    Add ( 'Abimbola Adeleke' );
    AtInsert ( 1, StrNew ( 'I want to go to Ibadan and then to Lagos' ) );
    { Delete ( pChar ( 'Abimbola' ) ); }  {<---- doesn't compile }
    f := @Xat;
    ForEach ( f ); { = FOR i := 1 TO Count DO WRITELN ( Strings ( i ) );}

    Clear;
    aCount := 0;

    Writeln;
    WRITELN ( '-------------------------------' );

    { prompt for a file name;
      read the file contents into the collection;
      and write the collection to "junk.txt
    }
    Write ( 'Filename: ' );
    Readln ( s );
    if s = '' then halt;

    Duplicates := TRUE;
    Sorted := FALSE;
    ReadFromFile ( s );

    ForEach ( f );

    WriteToFile ( 'junk.txt' );

    aCount := 0;

    {  read or write the collection to/from a stream
       stream filename = "dat.dat"
       "testcoll /r"  - to read from the stream
       otherwise, write to the stream
    }
    If ParamStr ( 1 ) = '/r' then begin { read the stored stream }
       Destroy;
       t.Init ( 'dat.dat', stOpen );
       Load ( t );
       ForEach ( f );   { display the stream contents }
    end else begin
       t.Init ( 'dat.dat', stCreate );
       Store ( t );  { write the collection to a stream }
    end;
    t.Done;

    Done;
  End;
End.
