{//////////////////////////////////////////////////////////////////////////}
{//                                                                      //}
{//         TEST PROGRAM for GPC  - TESTS THE DOS UNIT                   //}
{//                                                                      //}
{//         By Dr Abimbola A. Olowofoyeku (The African Chief);           //}
{//                                                                      //}
{//  This test program is released as part of the GNU Pascal project,    //}
{//  for the SOLE purpose of testing the routines in certain units.      //}
{//                                                                      //}
{//  This program is a free program; you can redistribute and/or modify  //}
{//  it under the terms of the GNU Library General Public License,       //}
{//  version 2, as published by the Free Software Foundation.            //}
{//                                                                      //}
{//  This library is distributed in the hope that it will be useful,     //}
{//  but WITHOUT ANY WARRANTY; without even the implied warranty of      //}
{//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       //}
{//  GNU Library General Public License for more details.                //}
{//                                                                      //}
{//  You should have received a copy of the GNU Library General Public   //}
{//  License along with this library (see the file COPYING.LIB);         //}
{//  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,  //}
{//  Cambridge, MA 02139, USA.                                           //}
{//                                                                      //}
{//  May 1997 - Dr A Olowofoyeku: laa12@keele.ac.uk                      //}
{//  Homepage: http://ourworld.compuserve.com/homepages/African_Chief    //}
{//////////////////////////////////////////////////////////////////////////}
PROGRAM testdos;

USES
GPCTYPES, SYSTEM, DOSH, DOS, STRINGS, GPCUTIL;

{$W-}
{$X+}

Var
W : byte;
D : _DISKFREE_T;
d1 : date;
t1 : time;
df : dFree;
i : integer;
s : string;
T : TSearchRec;
p, p1, p2, p3 : pchar;
l : longint;
hh, mm, ss, ss100 : Word;

begin
   getmem ( p,  260 );
   getmem ( p1, 67 );
   getmem ( p2, 13 );
   getmem ( p3, 4 );

   GetDir ( 0, s );
   Writeln ( 'Current directory = ', s );

   Write ( 'Current directory = ' );
   p := getcurdir ( p, 0 );
   writelnpchar ( p );

   Writeln;
   l := DiskSize ( 0 );
   Writeln ( 'Total Disk Space  = ', integer ( l ) Div 1024, 'kb' );

   l := DiskFree ( 0 );
   Writeln ( 'Free  Disk Space  = ', integer ( l ) Div 1024, 'kb' );

   Writeln;
   Write ( 'Press ENTER to continue ... ' );
   Readln;

   GetTime ( hh, mm, ss, ss100 );
   Write ( 'The Time is : ' );
   Write ( integer ( hh ), ':' );
   Write ( integer ( mm ) , ':' );
   Write ( integer ( ss ) , ':' );
   Writeln ( integer ( ss100 ) );

   GetDate ( hh, mm, ss, ss100 );
   Write ( 'The Date is : ' );
   Write ( integer ( ss )  , '/' );
   Write ( integer ( mm ), '/' );
   Writeln ( integer ( hh ) );

   Writeln;

   p := strpcopy ( p, 'c:\msdos\command.com' );
   filesplit ( p, p1, p2, p3 );
   writelnpchar ( p );
   writelnpchar ( p1 );
   writelnpchar ( p2 );
   writelnpchar ( p3 );

   Writeln;
   _GetDate ( d1 );
   With d1 do begin
      Write ( 'The Date is : ' );
      Write ( integer ( day )  , '/' );
      Write ( integer ( month ), '/' );
      Writeln ( integer ( year ) );
   end;

   Writeln;
   _GetTime ( t1 );
   With t1 do begin
      Write ( 'The Time is : ' );
      Write ( integer ( hour ), ':' );
      Write ( integer ( min ) , ':' );
      Write ( integer ( sec ) , ':' );
      Writeln ( integer ( hund ) );
   end;

   Writeln;
   W := _dos_getdiskfree ( 0, D );
   With D do begin
      Writeln ( 'Clusters (Total) = ', integer ( total_clusters ) );
      Writeln ( 'Clusters (Free)  = ', integer ( avail_clusters ) );
      Writeln ( 'Sectors/Cluster  = ', integer ( sectors_per_cluster ) );
      Writeln ( 'Bytes per Sector = ', integer ( bytes_per_sector ) );
   end;

   Writeln;
   GetDFree ( 0, df );
   With df do begin
      Writeln ( 'Space (Total)    = ', integer ( total ) );
      Writeln ( 'Space (Free)     = ', integer ( avail ) );
      Writeln ( 'Bytes per Sector = ', integer ( bsec ) );
      Writeln ( 'Sectors/Cluster  = ', integer ( sclus ) );
      l := total * bsec * sclus;
      writeln ( 'Total Disk Size  = ', integer ( l ), ' bytes' );
      l := avail * bsec * sclus;
      writeln ( 'Total Free Space = ', integer ( l ), ' bytes' );
   end;

   Writeln;
   if paramcount > 0 then s := paramstr ( 1 ) + Chr ( 0 )
   else begin
     write ( '"DIR" Filespec: ' );
     readln ( s );
     s := s + chr ( 0 );
   end;

   Writeln;
   FindFirst ( @s [1], Archive + ReadOnly + Directory, t );
   while doserror = 0 do begin
      with t do begin
        WritepChar ( ( Name ) );
        If ( attr and Directory <> 0 )
        then Writeln ( ' <dir>' )
        else Writeln;
      end;
      FindNext ( t );
   end;

   freemem ( p, 260 );
   freemem ( p1, 67 );
   freemem ( p2, 13 );
   freemem ( p3, 4 );
end.
