{//////////////////////////////////////////////////////////////////////////}
{//                                                                      //}
{//         TEST PROGRAM for GPC - tests EXITPROC and memory stuff       //}
{//                                                                      //}
{//         By Dr Abimbola A. Olowofoyeku (The African Chief);           //}
{//                                                                      //}
{//  This test program is released as part of the GNU Pascal project,    //}
{//  for the SOLE purpose of testing the routines in certain units.      //}
{//                                                                      //}
{//  This program is a free program; you can redistribute and/or modify  //}
{//  it under the terms of the GNU Library General Public License,       //}
{//  version 2, as published by the Free Software Foundation.            //}
{//                                                                      //}
{//  This library is distributed in the hope that it will be useful,     //}
{//  but WITHOUT ANY WARRANTY; without even the implied warranty of      //}
{//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       //}
{//  GNU Library General Public License for more details.                //}
{//                                                                      //}
{//  You should have received a copy of the GNU Library General Public   //}
{//  License along with this library (see the file COPYING.LIB);         //}
{//  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,  //}
{//  Cambridge, MA 02139, USA.                                           //}
{//                                                                      //}
{//  May 1997 - Dr A Olowofoyeku: laa12@keele.ac.uk                      //}
{//  Homepage: http://ourworld.compuserve.com/homepages/African_Chief    //}
{//////////////////////////////////////////////////////////////////////////}
PROGRAM TestMem;

USES
GPCTYPES, SYSTEM, XSYSTEM, SYSUTILS;
{$W-}
{$X+}

Var
SaveProc : pointer;

Procedure one;
Begin
  writeln ( 'This is the first exit procedure' );
end;{* one *}

Procedure two;
Begin
  writeln ( 'This is the second exit procedure' );
end;{* two *}

Procedure three;
Begin
  writeln ( 'This is the third exit procedure' );
  ExitProc := SaveProc; { restore ExitProc }
end;{* three *}

TYPE
ar  = array [1..100] of byte;
par = ^ar;

var
i : par;
j : integer;
p : pointer;

begin
 { you can use this exitproc stuff in many ways }
  SaveProc := ExitProc; { save the value of ExitProc }
  ExitProc := @three;
  p        := ExitProc;
  ExitProc := @two;
  j        := AddExitProc ( p );        { gets called last }
  j        := AddExitProc ( ExitProc ); { not necessary }
  j        := AddExitProc ( one );      { gets called first }

 { changeable memory allocation }
  MemAlloc ( i, 5 );                    { allocate memory for 5 }
  for j := 1 to 5 do i^ [j] := j;
  MemAlloc ( i, 15 );                   { increase to 15 !!! }
  for j := 6 to 15 do i^ [j] := j;
  for j := 1 to 15 do writeln ( i^ [j] );
  MemFree ( i );                  { free it all }
  halt;  { needs to be called for exit procedures }
end.
