{//////////////////////////////////////////////////////////////////////////}
{//                                                                      //}
{//      ANOTHER FILE COPY TEST PROGRAM for GPC (using STREAMS)          //}
{//                                                                      //}
{//         By Dr Abimbola A. Olowofoyeku (The African Chief);           //}
{//                                                                      //}
{//  This test program is released as part of the GNU Pascal project,    //}
{//  for the SOLE purpose of testing the routines in certain units.      //}
{//                                                                      //}
{//  This program is a free program; you can redistribute and/or modify  //}
{//  it under the terms of the GNU Library General Public License,       //}
{//  version 2, as published by the Free Software Foundation.            //}
{//                                                                      //}
{//  This library is distributed in the hope that it will be useful,     //}
{//  but WITHOUT ANY WARRANTY; without even the implied warranty of      //}
{//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       //}
{//  GNU Library General Public License for more details.                //}
{//                                                                      //}
{//  You should have received a copy of the GNU Library General Public   //}
{//  License along with this library (see the file COPYING.LIB);         //}
{//  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,  //}
{//  Cambridge, MA 02139, USA.                                           //}
{//                                                                      //}
{//  May 1997 - Dr A Olowofoyeku: laa12@keele.ac.uk                      //}
{//  Homepage: http://ourworld.compuserve.com/homepages/African_Chief    //}
{//////////////////////////////////////////////////////////////////////////}
PROGRAM TESTSTRM;

USES
GPCTYPES, SYSTEM, OBJECTS;
{$W-}

var
s, s1 : string;
p     : pDosStream;
t     : TDosStream;
i, j  : integer;
b     : pStreamBuf;


{ File copy function, using Streams }
Function StreamCopy ( Src, Dest : String ) : integer;

Const
BufSize = 32768; { filecopy buffer size; 32kb }

Var
sBuf,
dBuf : TDosStream;
p    : pStreamBuf;
b    : boolean;
i, j : integer;

Begin

  StreamCopy := - 1;
  sBuf.Init ( Src, stOpen );   { open source file }
  If sBuf.Status <> stOk then Exit;

  dBuf.Init ( Dest, stCreate ); { create target file }
  If dBuf.Status <> stOk then begin
    sBuf.Done;
    Exit;
  end;

  GetMem ( p, BufSize );
  b := ( sBuf.Status = stOk );
  i := 0;

  While ( b = true ) do begin
     j := sBuf.Read ( p^, BufSize );
     b := ( sBuf.Status = stOk );
     If b then begin
        Inc ( i, dBuf.Write ( p^, j ) );
        b := ( dBuf.Status = stOk );
     end;
  end;

  FreeMem ( p, BufSize );

  sBuf.Done;
  dBuf.Done;

  StreamCopy := i;

End; { * StreamCopy *}
{////////////////////////////////}

{ tests reading and writing to/from streams - to copy a file }
Procedure TestCopy;
Begin
   i := StreamCopy ( ParamStr ( 1 ), ParamStr ( 2 ) );
   Writeln ( i, ' bytes copied ' );
End;{* TestCopy *}
{////////////////////////////////}

{ tests writing to a stream }
Procedure TestPut ( s, code : string );
Begin

   If s = '' then Exit;

   if code = '/r'
   then i := stOpen        { read = "/r"}
   else i := stCreate;     { else create new file }

   t.init ( s, i );

   if t.status = stok then
   with t do begin
      if i = stCreate then begin
        Name := 'Testing a stream stuff';
        Put ( @t );
        Writeln ( 'Name=', Name );
        writeln ( 'handle=', handle );
        Writeln ( 'SelfID=', SelfID );
        {Write ( t, Sizeof ( t ) );}
      end
      else begin
        p := Get;
        Writeln ( 'SelfID=', p^.SelfID );
        writeln ( 'handle=', p^.handle );
        Writeln ( 'Name=', p^.Name );
        p^.Free;
        {Read ( t, Sizeof ( t ) );}
      end; { if i = stCreate }
      Done;
   end;{ with t}

End;{* TestPut *}
{////////////////////////////////}

{ tests reading a file via a stream }
Procedure TestRead ( s : string );
Begin
  if s = '' then halt;
  t.init ( s, 0 );
  getmem ( b, 1024 );
  If t.Status = stOk then
  While t.status = stOk do begin
     j := t.Read ( b^, 1024 );
     for i := 1 to j do write ( Chr ( b^ [i] ) );
  end;
  t.done;
  freemem ( b, 1024 );
End;{* TestRead *}
{////////////////////////////////}
{////////////////////////////////}
{////////////////////////////////}
{ Program }
Begin

   { copy - rem out to test the others }
   if ParamCount < 2 then begin
      Writeln ( 'Syntax = SCOPY <sourcefile> <destfile>' );
      Halt;
   end;
   TestCopy;

   {
   Writeln;
   Write ( 'filename to read/write stream: ' );
   Readln ( s );
   Write ( 'access code (type "/r" to read the stream): '
   Readln ( s1 );
   TestPut ( s, s1 );
   }

   {
   Writeln;
   Write ( 'filename to read from: ' );
   Readln ( s );
   TestRead ( s );
   }

End.
